using System;
using System.Collections.Generic;
using System.Text;

using YD = Yanesdk.Draw;

namespace CornerCrash
{
    class BGMap : IDisposable
    {
//        public const int MAPCHIP_WIDTH = 126 / 3;
//        public const int MAPCHIP_HEIGHT = 126 / 3;
        public const int MAPCHIP_WIDTH = 112;
        public const int MAPCHIP_HEIGHT = 112;

        public enum BGType
        {
            OVERLAP,
            NORMAL,
            BLOCK,
            TJIRO,
            JYUJIRO,
            CORNER,
            GOAL,
        }
        
        public enum Direct
        {
            VOID = 0,
            TOP,
            BOTTOM,
            LEFT,
            RIGHT,
        }
        
        int[][] map;
        int[][] directmap;
        BGPart[] bgpart;

        string[] filenames = {
                "douro/default.gif",
                "douro/douro1.gif",
                "douro/douro2.gif",
                "douro/douro-kado1.gif",
                "douro/douro-kado2.gif",
                "douro/douro-kado3.gif",
                "douro/douro-kado4.gif",
                "douro/douro-teisisen1.gif",
                "douro/douro-teisisen2.gif",
                "douro/douro-teisisen3.gif",
                "douro/douro-teisisen4.gif",
                "douro/Tjiro1.gif",
                "douro/Tjiro2.gif",
                "douro/Tjiro3.gif",
                "douro/Tjiro4.gif",
                "douro/+jiro.gif",
                "tatemono/gacco.gif"
        };
        static BGType[] bgtypes = 
        {
            BGType.BLOCK,
            BGType.NORMAL,
            BGType.NORMAL,
            BGType.CORNER,
            BGType.CORNER,
            BGType.CORNER,
            BGType.CORNER,
            BGType.NORMAL,
            BGType.NORMAL,
            BGType.NORMAL,
            BGType.NORMAL,
            BGType.TJIRO,
            BGType.TJIRO,
            BGType.TJIRO,
            BGType.TJIRO,
            BGType.JYUJIRO,
            BGType.GOAL,
        };

        static Direct[] bgdirects = 
        {
            Direct.VOID,
            Direct.RIGHT,
            Direct.TOP,
            Direct.LEFT,
            Direct.BOTTOM,
        };

        public BGMap(int[][] pMap,int[][] pDMap)
        {
            directmap = pDMap;
            map = pMap;
        }

        public void LoadBmp()
        {
            bgpart = new BGPart[filenames.Length];

            for (int i = 0; i < bgpart.Length; i++)
            {
                bgpart[i] = new BGPart();
                bgpart[i].LoadBmp(@"bgimg/" + filenames[i]);
            }
        }

        public Direct getBGDirects(int val)
        {
            if ((val < 0) || (val >= bgdirects.Length))
            {
                throw new CornerCrashException(this, System.Reflection.MethodBase.GetCurrentMethod(),
                    "ړ`}bv̒`lsłB (l : " + val + "w肳܂B)");
            }

            return bgdirects[val];
        }

        public int[][] DirectMap
        {
            get
            {
                return directmap;
            }
        }

        public int[][] Map
        {
            get
            {
                return map;
            }
        }

        public BGPart[] Part
        {
            get
            {
                return bgpart;
            }
        }

        public BGType[] BGTypes
        {
            get
            {
                return bgtypes;
            }
        }

        public void Dispose()
        {
            if(bgpart != null)
            {
                foreach (BGPart part in bgpart)
                {
                    if (part != null)
                    {
                        part.Dispose();
                    }
                }
            }
            bgpart = null;
        }
    }
}
