using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;

using YD = Yanesdk.Draw;

namespace CornerCrash
{
    class BGPart : IDisposable
    {
        protected YD.GlTexture texture;
        protected YD.Screen2DGl screen;
        protected Bitmap bmp;
        public BaseSprite sprite;

        public int x, y;

        public BGPart()
        {

        }

        public BGPart(YD.Screen2DGl pscreen)
        {
            Init(pscreen, null);
        }

        public BGPart(YD.Screen2DGl pscreen, YD.GlTexture ptexture)
        {
            Init(pscreen, ptexture);
        }

        protected void Init(YD.Screen2DGl pscreen, YD.GlTexture ptexture)
        {
            screen = pscreen;
            LoadSprite();
            texture = ptexture;
            sprite.setTexture(texture);
            x = 0;
            y = 0;
        }

        public virtual void LoadSprite()
        {
            sprite = new BaseSprite(screen);
        }

        public void LoadBmp(string filename)
        {
            bmp = Util.LoadBmp(filename);
        }

        public void setTexture(YD.Screen2DGl pscreen, YD.GlTexture ptexture)
        {
            Init(pscreen, ptexture);
        }

        public Bitmap Bmp
        {
            get
            {
                return bmp;
            }
        }

        public void Dispose()
        {
            if(texture != null)
            {
                if(texture.Loaded == true)
                {
                    texture.Dispose();
                }
            }
            texture = null;
            if(bmp != null)
            {
                bmp.Dispose();
            }
            bmp = null;
            if(sprite != null)
            {
                sprite.Dispose();
            }
            sprite = null;
        }
    }
}