using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;

namespace CornerCrash
{
    class BaseLayer : IDisposable
    {
        public enum LayerType
        {
            BASE,
            BG,
            CHARACTER,
            POINTPRT,
            EVENTEXEC,
            LIMITTIME,
            TITLE,
            COUNTER,
            BLIND,
        }
        
        int width;
        int height;
        protected int  basex, basey;

        protected Character basePointChar;
        protected List<Character> characters;

        public BaseLayer()
        {
            Init(0, 0);
        }

        public BaseLayer(int w, int h)
        {
            Init(w, h);
        }

        public virtual void Init(int w , int h)
        {
            width = w;
            height = h;
        }

        public virtual void DrawLayer()
        {

        }

        protected void CnvCharPointToBasePoint()
        {
            if (basePointChar != null)
            {
                basex = (basePointChar.x + (basePointChar.sprite.width / 2))
                            - (CornerCrashDefine.WINDOW_WIDTH / 2);
                basey = (basePointChar.y + (basePointChar.sprite.height / 2))
                            - (CornerCrashDefine.WINDOW_HEIGHT / 2);

                if (basex < 0)
                {
                    basex = 0;
                }
                else if ((basex + CornerCrashDefine.WINDOW_WIDTH) > Width)
                {
                    basex = Width - CornerCrashDefine.WINDOW_WIDTH;
                }

                if (basey < 0)
                {
                    basey = 0;
                }
                else if ((basey + CornerCrashDefine.WINDOW_HEIGHT) > Height)
                {
                    basey = Height - CornerCrashDefine.WINDOW_HEIGHT;
                }
            }

        }

        public int Width
        {
            get
            {
                return width;
            }

            set
            {
                if (value >= 0)
                {
                    width = value;
                }
                else
                {
                    width = 0;
                }
            }
        }
        public int Height
        {
            get
            {
                return height;
            }

            set
            {
                if (value >= 0)
                {
                    height = value;
                }
                else
                {
                    height = 0;
                }
            }
        }

        public virtual void Control()
        {

        }

        public Character baseChar
        {
            set
            {
                basePointChar = value;
            }
        }

        public virtual LayerType Type
        {
            get
            {
                return LayerType.BASE;
            }
        }

        public List<Character> Characters
        {
            get
            {
                return characters;
            }
            set
            {
                characters = value;
            }
        }

        public virtual void Dispose()
        {
            basePointChar = null;
            //Ȃ
        }
    }
}
