using System;
using System.Collections.Generic;
using System.Text;

using YD = Yanesdk.Draw;

namespace CornerCrash
{
    class BaseSprite : IDisposable
    {
        int _x, _y;
        
        
        YD.GlTexture texture;
        YD.Screen2DGl screen;

        public bool enable;
        private bool isonscreen;

        public BaseSprite(YD.Screen2DGl prmscreen, YD.GlTexture prmtexture)
        {
            Init(prmscreen, prmtexture);
        }

        public BaseSprite(YD.Screen2DGl prmscreen)
        {
            Init(prmscreen, null);
        }

        public void Init(YD.Screen2DGl prmscreen, YD.GlTexture prmtexture)
        {
            screen = prmscreen;
            texture = prmtexture;
            _x = 0;
            _y = 0;
            enable = false;
            isonscreen = false;
        }

        public void setTexture(YD.GlTexture ptexture)
        {
            texture = ptexture;
        }

        public void Draw()
        {
            if (enable == true)
            {
                screen.Blt(texture, _x, _y);
                if (texture == null)
                {
                    throw new CornerCrashException(this, System.Reflection.MethodBase.GetCurrentMethod(),
                        "eNX`[ւ̎QƂݒ肳Ă܂B");
                }
            }
        }

        public void Draw(int px, int py)
        {
            x = px;
            y = py;
            Draw();
        }

        public void Move(int px, int py)
        {
            x += px;
            y += py;
            Draw();
        }

        public int x
        {
            get
            {
                return _x;
            }
            set
            {
                _x = value;

                if (texture == null)
                {
                    return;
                }

                isonscreen = true;
                if (_x < (-texture.Width))
                {
                    isonscreen = false;
                }

                if (_x > CornerCrashDefine.WINDOW_WIDTH)
                {
                    isonscreen = false;
                }
            }
        }

        public int y
        {
            get
            {
                return _y;
            }
            set
            {
                _y = value;

                if (texture == null)
                {
                    return;
                }

                isonscreen = true;
                if (_y < (-texture.Height))
                {
                    isonscreen = false;
                }

                if (_y > CornerCrashDefine.WINDOW_HEIGHT)
                {
                    isonscreen = false;
                }
            }
        }

        public int width
        {
            get
            {
                if (texture == null)
                {
                    return 0;
                }

                return (int)texture.Width;
            }

        }

        public int height
        {
            get
            {
                if (texture == null)
                {
                    return 0;
                }

                return (int)texture.Height;
            }

        }

        public bool IsOnscreen
        {
            get
            {
                return isonscreen;
            }
        }

        public virtual void Dispose()
        {
            if(texture != null)
            {
                if(texture.Loaded == true)
                {
                    texture.Dispose();
                    texture = null;
                }
            }
        }
    }
}
