using System;
using System.Collections.Generic;
using System.Text;
using YD = Yanesdk.Draw;

namespace CornerCrash
{
    class CharacterFactory
    {
        private static CharacterFactory instance;

        private CharacterFactory()
        {

        }

        public static CharacterFactory getInstance()
        {
            if (instance != null)
            {
                return instance;
            }
            instance = new CharacterFactory();
            return instance;
        }

        public Character GenerateChar(CornerCrashDefine.characterType type,
            YD.Screen2DGl pscreen, BGMap pMap)
        {
            switch (type)
            {
                case CornerCrashDefine.characterType.Player:
                    return new PlayerChar(pscreen, pMap);
                case CornerCrashDefine.characterType.Kaisyain:
                    return new Kaisyain(pscreen, pMap);
                case CornerCrashDefine.characterType.Onyanoko:
                    return new OnyanokoBase(pscreen, pMap);
                case CornerCrashDefine.characterType.Onyanoko2:
                    return new Onyanoko2(pscreen, pMap);
                case CornerCrashDefine.characterType.Yandere:
                    return new Yandere(pscreen, pMap);
                case CornerCrashDefine.characterType.Uho:
                    return new UhoGoodMan(pscreen, pMap);
                case CornerCrashDefine.characterType.Police:
                    return new Police(pscreen, pMap);
                default:
                    throw new CornerCrashException(this, System.Reflection.MethodBase.GetCurrentMethod(),
                        "`̃LN^[^Cvw肳܂B");
            }
        }

        public Character GenerateChar(string typestr,
            YD.Screen2DGl pscreen, BGMap pMap)
        {
            CharTypeString typelist = CharTypeString.getinstance();
            int type = 0;

            for(type = 0; type < typelist.Length ; type++)
            {
                if(typelist[type] == typestr)
                {
                    break;
                }
            }

            switch (type)
            {
                case (int)CornerCrashDefine.characterType.Player:
                    return new PlayerChar(pscreen, pMap);
                case (int)CornerCrashDefine.characterType.Kaisyain:
                    return new Kaisyain(pscreen, pMap);
                case (int)CornerCrashDefine.characterType.Onyanoko:
                    return new OnyanokoBase(pscreen, pMap);
                case (int)CornerCrashDefine.characterType.Onyanoko2:
                    return new Onyanoko2(pscreen, pMap);
                case (int)CornerCrashDefine.characterType.Uho:
                    return new UhoGoodMan(pscreen, pMap);
                default :
                    throw new CornerCrashException(this, System.Reflection.MethodBase.GetCurrentMethod(),
                        "`̃LN^[^Cvw肳܂B");
            }
}
    }
}
