using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;

using YD = Yanesdk.Draw;

namespace CornerCrash
{
    class CharacterLayer : BaseLayer
    {
        private long time;//ۂControl()\bȟĂяo

        public CharacterLayer(int w, int h)
        {
            Init(w, h);
        }

        public override void Init(int w, int h)
        {
            base.Init(w, h);
            characters = new List<Character>();
            time = 0;
            LimitTimes.getInstance().InitCurTime(GameState.getInstance().stage - 1);
        }

        public void setCharsToMap(YD.Screen2DGl pscreen, BGMap pMap, int[][] chMap)
        {
            for (int i = 0; i < chMap.Length; i++)
            {
                for (int j = 0; j < chMap[i].Length; j++)
                {
                    Character charp = null;
                    switch (chMap[i][j])
                    {
                        case 2:
                            charp = CharacterFactory.getInstance().GenerateChar(
                                CornerCrashDefine.characterType.Onyanoko, pscreen, pMap);
                            break;
                        case 3:
                            charp = CharacterFactory.getInstance().GenerateChar(
                                CornerCrashDefine.characterType.Onyanoko2, pscreen, pMap);
                            break;
                        case 4:
                            charp = CharacterFactory.getInstance().GenerateChar(
                                CornerCrashDefine.characterType.Kaisyain, pscreen, pMap);
                            break;
                        case 5:
                            charp = CharacterFactory.getInstance().GenerateChar(
                                CornerCrashDefine.characterType.Uho, pscreen, pMap);
                            break;
                        case 6:
                            charp = CharacterFactory.getInstance().GenerateChar(
                                CornerCrashDefine.characterType.Police, pscreen, pMap);
                            break;
                        case 7:
                            charp = CharacterFactory.getInstance().GenerateChar(
                                CornerCrashDefine.characterType.Yandere, pscreen, pMap);
                            break;
                        default:
                            break;
                    }

                    if (charp != null)
                    {
                        charp.setMapPosition(j, i);
                        charp.setCharacters(characters);
                        addCharacter(charp);
                    }
                }
            }
        }

        public void addCharacter(Character character)
        {
            characters.Add(character);
        }

        public void setRealPoint(Character charcter)
        {
            if (basePointChar != null)
            {
                CnvCharPointToBasePoint();
            }

            charcter.sprite.x = charcter.x - basex;
            charcter.sprite.y = charcter.y - basey;
            //Console.WriteLine("charcter.x = {0}", charcter.x);
            //Console.WriteLine("charcter.y = {0}", charcter.y);
            //Console.WriteLine("charcter.sprite.x = {0}", charcter.sprite.x);
            //Console.WriteLine("charcter.sprite.y = {0}", charcter.sprite.y);
        }

        public override void DrawLayer()
        {
            if ((GameState.getInstance().State == GameState.Mode.TITLE) ||
                (GameState.getInstance().State == GameState.Mode.GAMEOVER) ||
                (GameState.getInstance().State == GameState.Mode.STGSTART))
            {
                return;
            }

            for (int i = 0; i < characters.Count; i++)
            {
                setRealPoint(characters[i]);
                if ((characters[i].sprite.enable == true) && 
                    (characters[i].sprite.IsOnscreen == true) &&
                    (characters[i].enable == true))
                {
                    characters[i].sprite.Draw();
                   characters[i].drawIcon();
                }
            }
        }

        public override void Control()
        {
            if (GameState.getInstance().State == GameState.Mode.TITLE)
            {
                return;
            }

            Character charp = null;
            for (int i = 0 ; i < characters.Count ; i++)
            {
                charp = characters[i];
                if (charp.IsValid == false)
                {
                    charp.Dispose();
                    characters.RemoveAt(i);
                    if (i >= characters.Count)
                    {
                        return;
                    }
                    charp = Characters[i];
                }
                if (GameState.getInstance().State != GameState.Mode.MAIN)
                {
                    continue;
                }
                if (charp.enable == false)
                {
                    continue;
                }
                charp.Control();
            }

            if ((GameState.getInstance().State != GameState.Mode.EVENT) &&
                (GameState.getInstance().State != GameState.Mode.STGSTART))
            {
                time++;
                if ((time % 30) == 0)
                {
                    LimitTimes.getInstance().DecCurTime();
                }
            }
        }

        public long Time
        {
            get
            {
                return time;
            }
        }

        public override LayerType Type
        {
            get
            {
                return LayerType.CHARACTER;
            }
        }

        public override void Dispose()
        {
            base.Dispose();

            foreach (Character charp in characters)
            {
                if (charp.CharType == CornerCrashDefine.characterType.Player)
                {
                    continue;
                }
                charp.Dispose();
            }
            characters.Clear();
            characters = null;
        }
    }
}
