using System;
using System.Collections.Generic;
using System.Text;

using YD = Yanesdk.Draw;

namespace CornerCrash
{
    class ComCharacter : Character
    {
        protected Random movernd;

        protected bool isturn;

        protected Character player;

        protected YD.GlTexture[] textureList;
        protected int visionw;
        protected int movewait;

        enum speedMode
        {
            DEFAULT = 0,
        }

        protected ComCharacter()
        {
            beforeDirection = 0;
            player = null;//[jOp
            textureList = null;//[jOp
            visionw = BGMap.MAPCHIP_WIDTH;
        }

        public ComCharacter(YD.Screen2DGl pscreen, BGMap pMap)
            : base(pscreen, pMap)
        {
            mx = 0;
            my = 0;
            backmvstate = BackMoveSt.NoMove;
            movernd = new Random();
            sprite.enable = true;
            visionw = BGMap.MAPCHIP_WIDTH;
            isturn = false;
            movewait = 0;
        }

        public override void setMapPosition(int sx, int sy)
        {
            x = sx * BGMap.MAPCHIP_WIDTH;
            y = sy * BGMap.MAPCHIP_HEIGHT;

            movernd = new Random(sx * BGMap.MAPCHIP_WIDTH + sy);
        }

        protected virtual NowDirection ConvDirection(int move)
        {
            return ConvDirectionStatic(move);
        }

        public static NowDirection ConvDirectionStatic(int move)
        {
            switch (move)
            {
                case 0:
                    return NowDirection.TOP;
                case 1:
                    return NowDirection.BOTTOM;
                case 2:
                    return NowDirection.LEFT;
                case 3:
                    return NowDirection.RIGHT;
                case 4:
                    return NowDirection.NOTHING;
                default:
                    return NowDirection.VOID;
            }
        }

        protected virtual int MonitoringPlayer(NowDirection Direction)
        {
            return -1;
        }


        protected virtual NowDirection ChasePlayer()
        {
            if (MonitoringPlayer(nowdirect) >= 0)
            {
                return nowdirect;
            }

            if (MonitoringPlayer(NowDirection.TOP) >= 0)
            {
                return NowDirection.TOP;
            }

            if (MonitoringPlayer(NowDirection.BOTTOM) >= 0)
            {
                return NowDirection.BOTTOM;
            }

            if (MonitoringPlayer(NowDirection.LEFT) >= 0)
            {
                return NowDirection.LEFT;
            }

            if (MonitoringPlayer(NowDirection.RIGHT) >= 0)
            {
                return NowDirection.RIGHT;
            }

            return nowdirect;
        }

        public override void Dispose()
        {
            base.Dispose();

            if (textureList != null)
            {
                //foreach (YD.GlTexture val in textureList)
                //{
                    //if (val.Loaded == true)
                    //{
                    //    val.Dispose();g܂킷̂ŃRgAEgB
                    //}
                //}
                textureList = null;
            }
        }
    }
}
