using System;
using System.Collections.Generic;
using System.Text;

using YD = Yanesdk.Draw;

namespace CornerCrash
{
    class CounterLayer : BaseLayer
    {
        YD.Textures texture;
        YD.FontRepository fontrp;
        YD.FontLoader fontldr;
        int fontwidth;
        int fontcount;
        YD.Screen2DGl screen;
        DataRecord counterrec;
        int nowstage;

        enum DrawPos
        {
            x = 16,
            y = 40,
        }

        private bool[] IsDispcharTypes = {
            false, //"VOID",
            false, //"Player",
            true, //"Onyanoko",
            true, //"Onyanoko2",
            true, //"Yandere"
            true, //"Uho",
            false, //"Kaisyain",
            true, //"Police",
            false, //"BaseTypeEnd",
            //"TypeEnd", enum`̑̂̒萔̒lcharTypeStrings̗vfƈvdlƂB
        };
        
        public CounterLayer(YD.Screen2DGl pscreen)
        {
            screen = pscreen;
            fontwidth = 16;
            YD.SmartFontLoader smfldr = new Yanesdk.Draw.SmartFontLoader();
            fontldr = smfldr.LoadDefFile("mem:msgothic.ttc, " + fontwidth + ", 0, 0");
            fontrp = new YD.FontRepository(delegate { return new YD.GlTexture(); });
            fontrp.SetLoader(fontldr, 0);
            fontcount = 2;
            texture = new Yanesdk.Draw.Textures();
            nowstage = 0;
        }

        public void RefCounterInit(int stage)
        {
            nowstage = stage;
            if (counterrec == null)
            {
                counterrec = new DataRecord();
                HitCounters hitcounters = GameEventMng.getInstance().HitCounters;
                foreach (string key in hitcounters.DefKeys)
                {
                    counterrec[key, TypeCode.Int32] = 0;
                }
            }
        }

        public override void DrawLayer()
        {  
            if ((GameState.getInstance().State != GameState.Mode.MAIN) &&
                (GameState.getInstance().State != GameState.Mode.EVENT))
            {
                return;
            }

            if (counterrec == null)
            {
                throw new CornerCrashException(this, System.Reflection.MethodBase.GetCurrentMethod(),
                    "JE^[ւ̎QƂݒ肳Ă܂B");
            }

            if (nowstage != GameState.getInstance().stage)
            {
                throw new CornerCrashException(this, System.Reflection.MethodBase.GetCurrentMethod(),
                    "QƐ̃JE^[݂̃Xe[WƈقȂ܂B");
            }

            if (texture == null)
            {
                return;
            }
            texture = fontrp.GetTexture("Ԃ", 0);
            screen.Blt(texture, (int)DrawPos.x, (int)DrawPos.y);

            texture.Release();
            string key = "";
            int hindex = 0;
            for (int i = 0; i < counterrec.defkeys.Count; i++)
            {
                key = counterrec.defkeys[i];

                if (IsDispcharTypes[CharTypeString.getinstance().getIndex(key)] == false)
                {
                    continue;
                }

                texture = fontrp.GetTexture(string.Format(CharTypeDispString.getinstance()[key] +
                        "i{0," + fontcount.ToString() + "}A납{1," + fontcount.ToString() + "}j",
                        GameEventMng.getInstance().RefHitCounters(key),
                        GameEventMng.getInstance().RefBackHitCounters(key)
                        ), 0);

                screen.Blt(texture, (int)DrawPos.x, (int)DrawPos.y + (int)((fontwidth * (hindex + 1)) * 1.5));

                texture.Release();
                hindex++;
            }
        }

        public override LayerType Type
        {
            get
            {
                return LayerType.COUNTER;
            }
        }
    }
}
