using System;
using System.Collections.Generic;
using System.Text;

using Yanesdk.System;

namespace CornerCrash
{
    class DataTable : IDisposable
    {
        protected List<DataRecord> table;

        public DataTable()
        {
            table = new List<DataRecord>();
        }

        public virtual void ReadCsv(string filename)
        {
            List<List<string>> csvtbl;
            DataRecord csvrec;
            CSVReaderEx reader = new CSVReaderEx();
            reader.Read(filename);
            csvtbl = reader.CsvData;

            string[] labelList = new string[csvtbl[0].Count];

            for (int i = 0; i < labelList.Length; i++)
            {
                labelList[i] = csvtbl[0][i];
            }

            for (int i = 1; i < csvtbl.Count; i++)
            {
                csvrec = new DataRecord();
                for (int j = 0; j < labelList.Length;j++)
                {
                    csvrec[labelList[j]] = csvtbl[i][j];
                }
                table.Add(csvrec);
            }
        }

        public object this[int i, string key,TypeCode type]
        {
            get
            {
                return table[i][key, type];
            }
        }

        public virtual void Dispose()
        {
            if (table != null)
            {
                foreach (DataRecord rec in table)
                {
                    rec.Dispose();
                }
                table.Clear();
            }
            table = null;
        }
    }
}
