using System;
using System.Collections.Generic;
using System.Text;

using YD = Yanesdk.Draw;

namespace CornerCrash
{
    class EffectLayer : BaseLayer
    {
        YD.Screen2DGl screen;
        Queue<Effect> taskq;
        Effect task;
        static EffectLayer instance;

        private EffectLayer()
        {
            taskq = new Queue<Effect>();
            task = null;
        }

        public void Init(YD.Screen2DGl pscreen)
        {
            screen = pscreen;
            Effect.InitScreen(screen);
        }

        public static EffectLayer getInstance()
        {
            if (instance != null)
            {
                return instance;
            }

            instance = new EffectLayer();

            return instance;
        }

        public void ExecRequest(Effect.EffectType type)
        {
            taskq.Enqueue(new Effect(type));
        }

        public override void Control()
        {
            if ((GameState.getInstance().State != GameState.Mode.MAIN) &&
                (GameState.getInstance().State != GameState.Mode.EVENT))
            {
                foreach (Effect taskp in taskq)
                {
                    taskp.Dispose();
                }
                taskq.Clear();
                task = null;
                return;
            }
            
            if ((taskq.Count == 0) || (task != null))
            {
                return;
            }

            task = taskq.Dequeue();
        }

        public override void DrawLayer()
        {
            if (task == null)
            {
                return;
            }

            task.ExecEffect();

            if (task.EffectStat == Effect.Stat.END)
            {
                task = null;
            }
        }
    }
}
