using System;
using System.Collections.Generic;
using System.Text;
using YD = Yanesdk.Draw;

namespace CornerCrash
{
    class EventImageWindow
    {
        YD.Screen2DGl screen;
        YD.GlTexture texture;
        YD.Rect rect;
        bool openwindow_comp;
        int nowheight;

        static EventImageWindow instance;

        private EventImageWindow()
        {
            texture = new Yanesdk.Draw.GlTexture();
            rect = new Yanesdk.Draw.Rect();
            openwindow_comp = false;
            nowheight = 0;
        }

        public static EventImageWindow getInstance()
        {
            if (instance != null)
            {
                return instance;
            }

            instance = new EventImageWindow();
            return instance;
        }

        public void openWindow(string filename)
        {
            if (texture.Loaded == true)
            {
                texture.Release();
            }

            texture.Load(filename);
            nowheight = 0;
            openwindow_comp = false;
        }

        public void openWindow()
        {
            if (texture.Loaded == false)
            {
                return;
            }

            if (openwindow_comp == false)
            {
                nowheight += CornerCrashDefine.EVENT_WINDOW_HEIGHT / 30;//bOPENB
            }

            if (nowheight > CornerCrashDefine.EVENT_WINDOW_HEIGHT)
            {
                nowheight = CornerCrashDefine.EVENT_WINDOW_HEIGHT;
            }

            rect.SetRect(0, (CornerCrashDefine.EVENT_WINDOW_HEIGHT - nowheight) / 2,
                CornerCrashDefine.EVENT_WINDOW_WIDTH,
                ((CornerCrashDefine.EVENT_WINDOW_HEIGHT - nowheight) / 2) + nowheight);
            screen.Blt(texture, 0, CornerCrashDefine.WINDOW_HEIGHT - CornerCrashDefine.MSG_WINDOW_HEIGHT
                    - CornerCrashDefine.EVENT_WINDOW_HEIGHT +
                    ((CornerCrashDefine.EVENT_WINDOW_HEIGHT - nowheight) / 2), rect);

            if (nowheight == CornerCrashDefine.EVENT_WINDOW_HEIGHT)
            {
                openwindow_comp = true;
            }

            return;
        }

        public void closeWindow()
        {
            if (texture.Loaded == false)
            {
                return;
            }

            nowheight -= CornerCrashDefine.EVENT_WINDOW_HEIGHT / 30;//bOPENB

            if (nowheight < 0)
            {
                nowheight = 0;
            }

            rect.SetRect(0, (CornerCrashDefine.EVENT_WINDOW_HEIGHT - nowheight) / 2,
                CornerCrashDefine.EVENT_WINDOW_WIDTH,
                ((CornerCrashDefine.EVENT_WINDOW_HEIGHT - nowheight) / 2) + nowheight);
            screen.Blt(texture, 0, CornerCrashDefine.WINDOW_HEIGHT - CornerCrashDefine.MSG_WINDOW_HEIGHT
                    - CornerCrashDefine.EVENT_WINDOW_HEIGHT +
                    ((CornerCrashDefine.EVENT_WINDOW_HEIGHT - nowheight) / 2), rect);

            if (nowheight == 0)
            {
                openwindow_comp = false;
                nowheight = 0;
                texture.Release();
            }
        }

        public bool IsOpenComp
        {
            get
            {
                return openwindow_comp;
            }
        }

        public YD.Screen2DGl Screen
        {
            set
            {
                screen = value;
            }
        }
    }
}
