using System;
using System.Collections.Generic;
using System.Text;

namespace CornerCrash
{
    class EventTbl : DataTable
    {
        public const string eventid = "eventid";
        public const string msgtext = "msgtext";
        public const string imgfile = "imgfile";
        public const string nextevtid = "nextevtid";
        public const string jumpevtid = "jumpevtid";
        public const string type = "type";
        public const string setx = "setx";
        public const string sety = "sety";
        public const string chartype = "chartype";
        public const string upflags = "upflags";
        public const string downflags = "downflags";

        private string nextid;

        public EventTbl()
            : base()
        {
            nextid = "";
        }

        public DataRecord getEventRecord(string id)
        {
            foreach (DataRecord rec in table)
            {
                if (rec[eventid] == id)
                {
                    nextid = rec[nextevtid];
                    return rec;
                }
            }
            throw new CornerCrashException(this, System.Reflection.MethodBase.GetCurrentMethod(),
                "CxgID : " + id + " ܂B");
        }

        public DataRecord getEventRecord()
        {
            if (nextid == "end")
            {
                return null;
            }

            foreach (DataRecord rec in table)
            {
                if (rec[eventid] == nextid)
                {
                        nextid = rec[nextevtid];
                    return rec;
                }
            }
            throw new CornerCrashException(this, System.Reflection.MethodBase.GetCurrentMethod(),
                "CxgID : " + nextid + " ܂B");
        }
    }
}
