using System;
using System.Collections.Generic;
using System.Text;

namespace CornerCrash
{
    class FlagConditionTbl : DataTable
    {
        int recpt;

        static FlagConditionTbl instance;
        public Dictionary<string, bool> flaglist;

        public const string stageid = "stageid";
        public const string upflag = "upflags";
        public const string downflag = "downflags";
        public const string setflag = "setflags";
        public const string resetflag = "resetflags";

        private FlagConditionTbl()
            : base()
        {
            recpt = 0;
            flaglist = new Dictionary<string, bool>();
        }

        public static void GenInstance(string filename)
        {
            if (instance == null)
            {
                instance = new FlagConditionTbl();
            }

            instance.ReadCsv(filename);
        }

        public static FlagConditionTbl getInstance()
        {
            if (instance == null)
            {
                throw new CornerCrashException("FlagConditionTbl̃CX^XĂȂɂS炸AgetInstance()Ăяo܂B");
            }

            return instance;            
        }

        public override void ReadCsv(string filename)
        {
            base.ReadCsv(filename);
            //if (table.Count < 1)
            //{
                //throw new CornerCrashException(this, System.Reflection.MethodBase.GetCurrentMethod(),
                //    "Cxge[uɗLȃR[h܂B");
            //}
            recpt = 0;
        }

        private DataRecord getFirstRecord(int stage)
        {
            int i;
            for (i = 0; i < table.Count; i++)
            {
                if ((int)this[i, stageid, TypeCode.Int32] == stage)
                {
                    break;
                }
            }
            if (i == table.Count)
            {
//                throw new CornerCrashException(this, System.Reflection.MethodBase.GetCurrentMethod(),
//                    "Cxge[uɃXe[WID " + stage + " ܂B");
                return null;
            }
            recpt = i+1;
            return table[i];
        }

        private DataRecord getNextRecord(int stage)
        {
            int i;
            for (i = recpt; i < table.Count; i++)
            {
                if ((int)this[i, stageid, TypeCode.Int32] == stage)
                {
                    break;
                }
            }
            if (i == table.Count)
            {
                return null;
            }
            recpt = i+1;
            return table[i];
        }

        private List<DataRecord> getTable(int stage)
        {
            List<DataRecord> stgtbl = new List<DataRecord>();
            DataRecord rec;

            rec = getFirstRecord(stage);
            if (rec == null)
            {
                return stgtbl;
            }

            stgtbl.Add(rec);
            while ((rec = getNextRecord(stage)) != null)
            {
                stgtbl.Add(rec);
            }

            return stgtbl;
        }

        public static string[] getFlags(string flagfiled)
        {
            string[] flags = flagfiled.Split("\n".ToCharArray());

            for (int i = 0; i < flags.Length; i++)
            {
                flags[i] = flags[i].Trim();
            }

            return flags;
        }

        public bool IsUpFlags(string[] flags)
        {
            for (int i = 0; i < flags.Length; i++)
            {
                if (flaglist.ContainsKey(flags[i]) == false)
                {
                    return false;
                }

                if (flaglist[flags[i]] == false)
                {
                    return false;
                }
            }

            return true;
        }

        public bool IsDownFlags(string[] flags)
        {
            for (int i = 0; i < flags.Length; i++)
            {
                if (flaglist.ContainsKey(flags[i]) == false)
                {
                    continue;
                }

                if (flaglist[flags[i]] == true)
                {
                    return false;
                }
            }

            return true;
        }

        private void setUpFlags(string[] flags, bool flag)
        {
            for (int i = 0; i < flags.Length; i++)
            {
                flaglist[flags[i]] = flag; 
            }
        }

        private void setDownFlags(string[] flags, bool flag)
        {
            if (flag == true)
            {
                flag = false;
            }
            else
            {
                flag = true;
            }

            for (int i = 0; i < flags.Length; i++)
            {
                flaglist[flags[i]] = flag;
            }
        }

        public bool ExecExpression(string expression, int count)
        {
            expression = expression.Trim();
            bool hasval = false;
            int val = 0;
            for (int i = 0; i < expression.Length; i++)
            {
                if ((expression[i].ToString() == " ") ||
                    (expression[i].ToString() == "=") ||
                    (expression[i].ToString() == ">") ||
                    (expression[i].ToString() == "<") ||
                    (expression[i].ToString() == "!"))
                {
                    hasval = true;
                    val = int.Parse(expression.Substring(0, i));
                    expression = expression.Substring(i);
                }

                if (hasval == true)
                {
                    switch (expression)
                    {
                        case "==" :
                            return (val == count);
                        case ">" :
                            return (val > count);
                        case "<" :
                            return (val < count);
                        case ">=" :
                            return (val >= count);
                        case "<=" :
                            return (val <= count);
                        case "!=" :
                            return (val != count);
                        default :
                            break;
                    }
                }
            }
            throw new CornerCrashException(this, System.Reflection.MethodBase.GetCurrentMethod(),
                "̌`słB");

        }

        public void setFlags(string[] flags)
        {
            setUpFlags(flags, true);
        }

        public void resetFlags(string[] flags)
        {
            setDownFlags(flags, true);
        }

        public void setFlags(int stage)
        {
            List<DataRecord> flagtbl = getTable(stage);

            bool flag;
            List<string> columns;

            foreach (DataRecord rec in flagtbl)
            {
                flag = true;
                columns = rec.defkeys;

                foreach (string column in columns)
                {
                    switch (column)
                    {
                        case stageid:
                            break;
                        case setflag:
                            break;
                        case resetflag:
                            break;
                        case upflag:
                            if(IsUpFlags(FlagConditionTbl.getFlags(rec[column])) == false)
                            {
                                flag = false;
                            }
                            break;
                        case downflag:
                            if(IsDownFlags(FlagConditionTbl.getFlags(rec[column])) == false)
                            {
                                flag = false;
                            }
                            break;
                        default:
                            if(ExecExpression(rec[column], 
                                GameEventMng.getInstance().RefHitCounters(column)) == false)
                            {
                                flag = false;
                            }
                            break;
                    }
                }
                setUpFlags(getFlags(rec[setflag]), flag);
                setDownFlags(getFlags(rec[resetflag]), flag);
            }
        }
    }
}
