using System;
using System.Collections.Generic;
using System.Text;

using YD = Yanesdk.Draw;

namespace CornerCrash
{
    class GamePointLayer : BaseLayer
    {
        YD.Textures texture;
        YD.FontRepository fontrp;
        YD.FontLoader fontldr;
        int fontwidth;
        int fontcount;
        YD.Screen2DGl screen;
        PlayerChar player;

        public GamePointLayer(YD.Screen2DGl pscreen, PlayerChar charp)
        {
            screen = pscreen;
            player = charp;
            fontwidth = 24;
            fontcount = 10;
            YD.SmartFontLoader smfldr = new Yanesdk.Draw.SmartFontLoader();
            fontldr = smfldr.LoadDefFile("mem:msgothic.ttc, " + fontwidth + ", 0, 0");
            fontrp = new YD.FontRepository(delegate { return new YD.GlTexture(); });
            fontrp.SetLoader(fontldr, 0);
            texture = new Yanesdk.Draw.Textures();
        }

        public override void DrawLayer()
        {
            if ((GameState.getInstance().State == GameState.Mode.TITLE) ||
                (GameState.getInstance().State == GameState.Mode.GAMEOVER) ||
                (GameState.getInstance().State == GameState.Mode.STGSTART))
            {
                return;
            }

            if (texture == null)
            {
                return;
            }
            texture = fontrp.GetTexture(string.Format("ƂĂF{0:d" + fontcount.ToString() + "}",
                player.GamePoint), 0);
            screen.Blt(texture, 
                CornerCrashDefine.WINDOW_WIDTH - (fontwidth * (fontcount + "ƂĂF".Length)),
                fontwidth / 2);

            texture.Release();
        }

        public override LayerType Type
        {
            get
            {
                return LayerType.POINTPRT;
            }
        }
    }
}
