using System;
using System.Collections.Generic;
using System.Text;

namespace CornerCrash
{
    class HitCounters
    {
        private CharTypeString charTypeStrings;
        private CharTypeDispString chdispStrings;
        Dictionary<string, int> hitcounters;
        Dictionary<string, int> bkhitcounters;
        List<string> defkeys;

        public HitCounters()
            : base()
        {

        }

        public void Init()
        {
            charTypeStrings = CharTypeString.getinstance();
            chdispStrings = CharTypeDispString.getinstance();
            hitcounters = new Dictionary<string, int>();
            bkhitcounters = new Dictionary<string, int>();

            if ((charTypeStrings.Length != (int)CornerCrashDefine.characterType.TypeEnd) ||
                (chdispStrings.Length != (int)CornerCrashDefine.characterType.TypeEnd))
            {
                throw new CornerCrashException(this, System.Reflection.MethodBase.GetCurrentMethod(),
                    "CornerCrashDefine.characterTypéuTypeEndvȊOɑΉ{NX̕`̐słB");
                //TypeEndɑΉ镶`͕svB܂AȊOenumׂĂɑ΂ĈΈŕ`sdlƂB
            }

            defkeys = new List<string>();

            for (int i = 0; i < (int)CornerCrashDefine.characterType.BaseTypeEnd; i++)
            {
                defkeys.Add(charTypeStrings[i]);
                hitcounters[charTypeStrings[i]] = 0;
                bkhitcounters[charTypeStrings[i]] = 0;
            }
        }

        public int RefHitCounters(string key)
        {
            return hitcounters[key];
        }

        public int RefHitCounters(CornerCrashDefine.characterType key)
        {
            return hitcounters[charTypeStrings[(int)key]];
        }

        public void addHitcounter(CornerCrashDefine.characterType key, int cnt)
        {
            hitcounters[charTypeStrings[(int)key]] += cnt;
        }

        public void incHitcounter(CornerCrashDefine.characterType key)
        {
            hitcounters[charTypeStrings[(int)key]]++;
        }

        public int RefBackHitCounters(string key)
        {
            return bkhitcounters[key];
        }

        public int RefBackHitCounters(CornerCrashDefine.characterType key)
        {
            return bkhitcounters[charTypeStrings[(int)key]];
        }

        public void addBackHitcounter(CornerCrashDefine.characterType key, int cnt)
        {
            bkhitcounters[charTypeStrings[(int)key]] += cnt;
        }

        public void incBackHitcounter(CornerCrashDefine.characterType key)
        {
            bkhitcounters[charTypeStrings[(int)key]]++;
        }

        public void clearHitcounter(CornerCrashDefine.characterType key)
        {
            hitcounters[charTypeStrings[(int)key]] = 0;
            bkhitcounters[charTypeStrings[(int)key]] = 0;
        }

        public void clearHitcounter(string key)
        {
            hitcounters[key] = 0;
            bkhitcounters[key] = 0;
        }

        public void clearHitcounters()
        {
            foreach (string key in defkeys)
            {
                hitcounters[key] = 0;
                bkhitcounters[key] = 0;
            }
        }

        public List<string> DefKeys
        {
            get
            {
                return defkeys;
            }
        }
    }
}
