using System;
using System.Collections.Generic;
using System.Text;

namespace CornerCrash
{
    class HitEvtDefTbl : DataTable
    {
        public const string stageid = "stageid";
        public const string charid = "charid";
        public const string isback = "isback";
        public const string minhit = "min";
        public const string maxhit = "max";
        public const string upflags = "upflags";
        public const string downflags = "downflags";
        public const string execevent = "execevent";

        static HitEvtDefTbl instance;
        List<DataRecord> stagetbl;
        int recpt;

        private HitEvtDefTbl()
            : base()
        {

        }

        public static void GenInstance(string filename)
        {
            if (instance == null)
            {
                instance = new HitEvtDefTbl();
            }

            instance.ReadCsv(filename);
        }

        public static HitEvtDefTbl getInstance()
        {
            if (instance == null)
            {
                throw new CornerCrashException("HitEvtDefTbl̃CX^XĂȂɂS炸AgetInstance()Ăяo܂B");
            }

            return instance;
        }

        public void InitStage(int stage)
        {
            stagetbl = getTable(stage);
        }

        public override void ReadCsv(string filename)
        {
            base.ReadCsv(filename);
            recpt = 0;
        }

        private DataRecord getFirstRecord(int stage)
        {
            int i;
            for (i = 0; i < table.Count; i++)
            {
                if ((int)this[i, stageid, TypeCode.Int32] == stage)
                {
                    break;
                }
            }

            if (i == table.Count)
            {
                return null;
            }

            recpt = i + 1;
            return table[i];
        }

        private DataRecord getNextRecord(int stage)
        {
            int i;
            for (i = recpt; i < table.Count; i++)
            {
                if ((int)this[i, stageid, TypeCode.Int32] == stage)
                {
                    break;
                }
            }
            if (i == table.Count)
            {
                return null;
            }
            recpt = i + 1;
            return table[i];
        }

        private List<DataRecord> getTable(int stage)
        {
            List<DataRecord> stgtbl = new List<DataRecord>();
            DataRecord rec;

            rec = getFirstRecord(stage);
            if (rec == null)
            {
                return stgtbl;
            }

            stgtbl.Add(rec);
            while ((rec = getNextRecord(stage)) != null)
            {
                stgtbl.Add(rec);
            }

            return stgtbl;
        }

        public string EventSearch(CornerCrashDefine.characterType chartype, bool back)
        {
            string upflag = "";
            string downflag = "";

            for (int i = 0; i < stagetbl.Count; i++)
            {
                if (stagetbl[i][charid] == CharTypeString.getinstance()[(int)chartype])
                {
                    if (stagetbl[i][isback] != "")
                    {
                        if (back == true)
                        {
                            if ((int)stagetbl[i][isback, TypeCode.Int32] != 1)
                            {
                                continue;
                            }
                        }
                        else
                        {
                            if ((int)stagetbl[i][isback, TypeCode.Int32] == 1)
                            {
                                continue;
                            }
                        }
                    }
                    else if (back == true)
                    {
                        continue;
                    }

                    upflag = stagetbl[i][upflags];
                    if (upflag != "")
                    {
                        if(FlagConditionTbl.getInstance().IsUpFlags(upflag.Split("\n".ToCharArray())) == false)
                        {
                            continue;
                        }
                    }

                    downflag = stagetbl[i][downflags];
                    if (downflag != "")
                    {
                        if (FlagConditionTbl.getInstance().IsDownFlags(downflag.Split("\n".ToCharArray())) == false)
                        {
                            continue;
                        }
                    }

                    if (stagetbl[i][minhit] != "")
                    {
                        if (back == false)
                        {
                            if ((int)stagetbl[i][minhit, TypeCode.Int32] >
                                GameEventMng.getInstance().RefHitCounters(chartype))
                            {
                                continue;
                            }
                        }
                        else
                        {
                            if ((int)stagetbl[i][minhit, TypeCode.Int32] >
                                GameEventMng.getInstance().RefBackHitCounters(chartype))
                            {
                                continue;
                            }
                        }
                    }

                    if (stagetbl[i][maxhit] != "")
                    {
                        if (back == false)
                        {
                            if ((int)stagetbl[i][maxhit, TypeCode.Int32] <
                                GameEventMng.getInstance().RefHitCounters(chartype))
                            {
                                continue;
                            }
                        }
                        else
                        {
                            if ((int)stagetbl[i][maxhit, TypeCode.Int32] <
                                GameEventMng.getInstance().RefBackHitCounters(chartype))
                            {
                                continue;
                            }
                        }
                    }

                    return stagetbl[i][execevent];
                }
            }

            return null;
        }
    }
}
