using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using YD = Yanesdk.Draw;

namespace CornerCrash
{
    class ImageLayerInfo : IDisposable
    {
        public int x;
        public int y;

        public Bitmap image;
        private string path;

        public ImageLayerInfo(string val, int x, int y)
        {
            Init(val, Util.LoadBmp(val), x, y);
        }

        public ImageLayerInfo(string val)
        {
            Init(val, Util.LoadBmp(val), 0, 0);
        }

        public ImageLayerInfo(Bitmap val, int x, int y)
        {
            Init(null, val, x, y);
        }

        public ImageLayerInfo(Bitmap val)
        {
            Init(null, val, 0, 0);
        }

        private void Init(string imgpath, Bitmap val, int px, int py)
        {
            x = px;
            y = py;

            image = val;
            path = imgpath;
        }

        public ImageLayerInfo(ImageLayerInfo src)
        {
            x = src.x;
            y = src.y;

            image = new Bitmap(src.image);
        }

        public void LoadImage(string imgpath)
        {
            path = imgpath;
            if (image != null)
            {
                image.Dispose();
            }

            image = Util.LoadBmp(path);
        }

        public void ReleaseImage()
        {
            if (image != null)
            {
                image.Dispose();
                image = null;
            }
        }

        public void ResumeImage()
        {
            if (path == null)
            {
                throw new CornerCrashException(this, System.Reflection.MethodBase.GetCurrentMethod(),
                    "C[W̃pXۑĂȂ߁Ał܂B");
            }

            image = Util.LoadBmp(path);
        }

        public virtual void Dispose()
        {
            if (image != null)
            {
                image.Dispose();
                image = null;
            }
        }
    }
}
