using System;
using System.Collections.Generic;
using System.Text;

using YD = Yanesdk.Draw;

namespace CornerCrash
{
    class Kaisyain : ComCharacter
    {
        public Kaisyain(YD.Screen2DGl pscreen, BGMap pMap)
            : base(pscreen, pMap)
        {
            mx = 3;
            my = 3;
        }

        public override void LoadSprite()
        {
            textureList = KaisyainTexture.getInstance().TextureList;
            sprite = new BaseSprite(screen, textureList[(int)KaisyainTexture.TEXTURE.BOTTOM]);
            beforeDirection = (int)KaisyainTexture.TEXTURE.BOTTOM;
        }

        public override void Control()
        {
            int move = movernd.Next();

            move = move % 30;

            NowDirection movedirect = ConvDirection(move);

            switch (movedirect)
            {
                case NowDirection.TOP:
                    decAnimInterval();
                    MoveToTop();
                    break;
                case NowDirection.BOTTOM:
                    decAnimInterval();
                    MoveToBottom();
                    break;
                case NowDirection.LEFT:
                    decAnimInterval();
                    MoveToLeft();
                    break;
                case NowDirection.RIGHT:
                    decAnimInterval();
                    MoveToRight();
                    break;
                default:
                    MoveNothing();
                    break;
            }
            nowdirect = movedirect;
        }

        protected override Character.NowDirection ConvDirection(int move)
        {
            if (move > 3)
            {
                return nowdirect;
            }

            NowDirection direct = base.ConvDirection(move);
            return direct;
        }

        protected override bool IsXMove(bool isadd)
        {
            if (base.IsXMove(isadd) == false)
            {
                return false;
            }

            return true;
        }

        protected override bool IsYMove(bool isadd)
        {
            if (base.IsYMove(isadd) == false)
            {
                return false;
            }

            return true;
        }

        protected bool IsChangeDirection(KaisyainTexture.TEXTURE now)
        {
            return KaisyainTexture.IsChangeDirection(now, beforeDirection);
        }

        private void MoveToTop()
        {
            if ((animinterval <= 0) || (IsChangeDirection(KaisyainTexture.TEXTURE.TOP) == true))
            {
                if (backmvstate == BackMoveSt.MoveR)
                {
                    sprite.setTexture(textureList[(int)KaisyainTexture.TEXTURE.TOP2]);
                    beforeDirection = (int)KaisyainTexture.TEXTURE.TOP2;
                    backmvstate = BackMoveSt.MoveL;
                }
                else
                {
                    sprite.setTexture(textureList[(int)KaisyainTexture.TEXTURE.TOP1]);
                    beforeDirection = (int)KaisyainTexture.TEXTURE.TOP1;
                    backmvstate = BackMoveSt.MoveR;
                }
                animinterval = animintervalmax;
            }

            if (IsYMove(false) == false)
            {
                return;
            }
            y -= my;
        }

        private void MoveToBottom()
        {
            if ((animinterval <= 0) || (IsChangeDirection(KaisyainTexture.TEXTURE.BOTTOM) == true))
            {
                if (backmvstate == BackMoveSt.MoveR)
                {
                    sprite.setTexture(textureList[(int)KaisyainTexture.TEXTURE.BOTTOM2]);
                    beforeDirection = (int)KaisyainTexture.TEXTURE.BOTTOM2;
                    backmvstate = BackMoveSt.MoveL;
                }
                else
                {
                    sprite.setTexture(textureList[(int)KaisyainTexture.TEXTURE.BOTTOM1]);
                    beforeDirection = (int)KaisyainTexture.TEXTURE.BOTTOM1;
                    backmvstate = BackMoveSt.MoveR;
                }
                animinterval = animintervalmax;
            }

            if (IsYMove(true) == false)
            {
                return;
            }
            y += my;
        }


        private void MoveToLeft()
        {
            if ((animinterval <= 0) || (IsChangeDirection(KaisyainTexture.TEXTURE.LEFT) == true))
            {
                if (backmvstate == BackMoveSt.MoveR)
                {
                    sprite.setTexture(textureList[(int)KaisyainTexture.TEXTURE.LEFT2]);
                    beforeDirection = (int)KaisyainTexture.TEXTURE.LEFT2;
                    backmvstate = BackMoveSt.MoveL;
                }
                else
                {
                    sprite.setTexture(textureList[(int)KaisyainTexture.TEXTURE.LEFT1]);
                    beforeDirection = (int)KaisyainTexture.TEXTURE.LEFT1;
                    backmvstate = BackMoveSt.MoveR;
                }
                animinterval = animintervalmax;
            }

            if (IsXMove(false) == false)
            {
                return;
            }
            x -= mx;
        }

        private void MoveToRight()
        {
            if ((animinterval <= 0) || (IsChangeDirection(KaisyainTexture.TEXTURE.RIGHT) == true))
            {
                if (backmvstate == BackMoveSt.MoveR)
                {
                    sprite.setTexture(textureList[(int)KaisyainTexture.TEXTURE.RIGHT2]);
                    beforeDirection = (int)KaisyainTexture.TEXTURE.RIGHT2;
                    backmvstate = BackMoveSt.MoveL;
                }
                else
                {
                    sprite.setTexture(textureList[(int)KaisyainTexture.TEXTURE.RIGHT1]);
                    beforeDirection = (int)KaisyainTexture.TEXTURE.RIGHT1;
                    backmvstate = BackMoveSt.MoveR;
                }
                animinterval = animintervalmax;
            }

            if (IsXMove(true) == false)
            {
                return;
            }
            x += mx;
        }

        private void MoveNothing()
        {
            backmvstate = BackMoveSt.NoMove;

            switch (beforeDirection)
            {
                case (int)KaisyainTexture.TEXTURE.TOP1:
                    beforeDirection = (int)KaisyainTexture.TEXTURE.TOP;
                    break;

                case (int)KaisyainTexture.TEXTURE.TOP2:
                    beforeDirection = (int)KaisyainTexture.TEXTURE.TOP2;
                    break;

                case (int)KaisyainTexture.TEXTURE.RIGHT1:
                    beforeDirection = (int)KaisyainTexture.TEXTURE.RIGHT;
                    break;

                case (int)KaisyainTexture.TEXTURE.RIGHT2:
                    beforeDirection = (int)KaisyainTexture.TEXTURE.RIGHT;
                    break;

                case (int)KaisyainTexture.TEXTURE.LEFT1:
                    beforeDirection = (int)KaisyainTexture.TEXTURE.LEFT;
                    break;

                case (int)KaisyainTexture.TEXTURE.LEFT2:
                    beforeDirection = (int)KaisyainTexture.TEXTURE.LEFT;
                    break;

                case (int)KaisyainTexture.TEXTURE.BOTTOM1:
                    beforeDirection = (int)KaisyainTexture.TEXTURE.BOTTOM;
                    break;

                case (int)KaisyainTexture.TEXTURE.BOTTOM2:
                    beforeDirection = (int)KaisyainTexture.TEXTURE.BOTTOM;
                    break;
                default:
                    break;
            }
            sprite.setTexture(textureList[beforeDirection]);
        }

        public override void HitofCharNotice(Character charp)
        {
            if (charp.CharType == CornerCrashDefine.characterType.Uho)
            {
                isvalid = false;
            }
        }

        public override CornerCrashDefine.characterType CharType
        {
            get
            {
                return CornerCrashDefine.characterType.Kaisyain;
            }
        }
    }
}
