using System;
using System.Collections.Generic;
using System.Text;

using YD = Yanesdk.Draw;

namespace CornerCrash
{
    class LimitTimeLayer : BaseLayer
    {
        YD.Textures texture;
        YD.FontRepository fontrp;
        YD.FontLoader fontldr;
        int fontwidth;
        int fontcount;
        YD.Screen2DGl screen;

        public LimitTimeLayer(YD.Screen2DGl pscreen)
        {
            screen = pscreen;
            fontwidth = 24;
            fontcount = 3;
            YD.SmartFontLoader smfldr = new Yanesdk.Draw.SmartFontLoader();
            fontldr = smfldr.LoadDefFile("mem:msgothic.ttc, " + fontwidth + ", 0, 0");
            fontrp = new YD.FontRepository(delegate { return new YD.GlTexture(); });
            fontrp.SetLoader(fontldr, 0);
            texture = new Yanesdk.Draw.Textures();
        }

        public override void DrawLayer()
        {
            if ((GameState.getInstance().State == GameState.Mode.TITLE) ||
                (GameState.getInstance().State == GameState.Mode.GAMEOVER) ||
                (GameState.getInstance().State == GameState.Mode.STGSTART))
            {
                return;
            }

            if (texture == null)
            {
                return;
            }

            texture = fontrp.GetTexture(string.Format("c莞ԁF{0:d" + fontcount.ToString() + "}",
                  LimitTimes.getInstance().CurTime + "b"), 0);
            screen.Blt(texture,
                fontwidth / 2,
                fontwidth / 2);

            texture.Release();
        }

        public override LayerType Type
        {
            get
            {
                return LayerType.LIMITTIME;
            }
        }
    }
}
