using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using Yanesdk.System;

namespace CornerCrash
{
    class MapDataFile
    {
        private string basepath;
        private string mapdatapath;
        private string chardatapath;
        private string mvdatapath;

        public MapDataFile(string dirpath, string mapdata, string chardata, string mvdata)
        {
            basepath = dirpath;
            mapdatapath = mapdata;
            chardatapath = chardata;
            mvdatapath = mvdata;
            if (basepath != "")
            {
                mapdatapath = basepath + "/" + mapdatapath;
                chardatapath = basepath + "/" + chardatapath;
                mvdatapath = basepath + "/" + mvdatapath;
            }
        }

        public string[] getMapData()
        {
            if (Util.IsExist(mapdatapath) == false)
            {
                throw new FileNotFoundException("w肵t@C܂B", mapdatapath);
            }
            byte[] buff = null;

            buff = FileSys.Read(mapdatapath);

            return Util.CnvByteArrayToStr(buff).Split("\n".ToCharArray());
        }

        public string[] getChMapData()
        {
            if (Util.IsExist(chardatapath) == false)
            {
                throw new FileNotFoundException("w肵t@C܂B", chardatapath);
            }

            byte[] buff = null;

            buff = FileSys.Read(chardatapath);

            return Util.CnvByteArrayToStr(buff).Split("\n".ToCharArray());
        }

        public string[] getMoveMapData()
        {
            if (Util.IsExist(mvdatapath) == false)
            {
                throw new FileNotFoundException("w肵t@C܂B", mvdatapath);
            }

            byte[] buff = null;
     
            buff = FileSys.Read(mvdatapath);

            return Util.CnvByteArrayToStr(buff).Split("\n".ToCharArray());
        }

        public int[][] getCnvMapData()
        {
            string[] buff = getMapData();
            if (buff == null)
            {
                return null;
            }
            return CnvMapDataFromStr(buff);
        }

        public int[][] getCnvChMapData()
        {
            string[] buff = getChMapData();
            if (buff == null)
            {
                return null;
            }
            return CnvMapDataFromStr(buff);
        }

        public int[][] getCnvMoveMapData()
        {
            string[] buff = getMoveMapData();
            if (buff == null)
            {
                return null;
            }
            return CnvMapDataFromStr(buff);
        }

        public int[][] CnvMapDataFromStr(string[] mapdatastrrows)
        {
            int[][] mapdata = new int[mapdatastrrows.Length - 1][];
            for (int i = 0; i < (mapdatastrrows.Length - 1); i++)
            {
                string rowstr = mapdatastrrows[i];
                int[] mapdatarow = new int[rowstr.Length / 2];

                for (int j = 0; j < (mapdatarow.Length); j++)
                {
                    mapdatarow[j] = Convert.ToInt32(rowstr.Substring(j * 2, 2), 16);
                }
                mapdata[i] = mapdatarow;
            }

            return mapdata;
        }
        
        public static string MakeFullName(string filename)
        {
            if (filename[0].ToString() == "/")
            {
                return filename;
            }

            if (filename[1].ToString() == ":")
            {
                return filename;
            }

            return FileSys.ConcatPath(Directory.GetCurrentDirectory(), filename);
        }

        public string mapDataPath
        {
            get
            {
                return mapdatapath;
            }
        }

        public string chmapDataPath
        {
            get
            {
                return chardatapath;
            }
        }

        public string mvmapDataPath
        {
            get
            {
                return mvdatapath;
            }
        }
    }
}
