using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using Yanesdk.System;

namespace CornerCrash
{
    class MapDataFiles
    {
        private List<MapDataFile> datafiles;
        private string basepath;
        private string mapfile;
        private string chmapfile;
        private string mvmapfile;
        private string exmaproot;

        public MapDataFiles(string dirpath, string exrootdir, string mappath, string chmappath, string mvmappath)
        {
            datafiles = new List<MapDataFile>();
            mapfile = mappath;
            chmapfile = chmappath;
            mvmapfile = mvmappath;

            exmaproot = exrootdir;
            basepath = dirpath;
        }

        public void ReadMapFiles()
        {
            if (Util.IsExist(mapfile) == false)
            {
                throw new FileNotFoundException("t@C " + mapfile + " ܂B");
            }

            if (Util.IsExist(chmapfile) == false)
            {
                throw new FileNotFoundException("t@C " + chmapfile + " ܂B");
            }

            if (Util.IsExist(mvmapfile) == false)
            {
                throw new FileNotFoundException("t@C " + mvmapfile + " ܂B");
            }
            byte[] buff;

            buff = FileSys.Read(mapfile);

            string[] maplist = Util.CnvByteArrayToStr(buff).Split("\n".ToCharArray());

            buff = FileSys.Read(chmapfile);

            string[] chmaplist = Util.CnvByteArrayToStr(buff).Split("\n".ToCharArray());

            buff = FileSys.Read(mvmapfile);

            string[] mvmaplist = Util.CnvByteArrayToStr(buff).Split("\n".ToCharArray());

            if (maplist.Length != chmaplist.Length)
            {
                throw new CornerCrashException(this, System.Reflection.MethodBase.GetCurrentMethod(),
                    "}bvt@CƃLN^[}bvt@C̒`v܂B");
            }

            if (maplist.Length != mvmaplist.Length)
            {
                throw new CornerCrashException(this, System.Reflection.MethodBase.GetCurrentMethod(),
                    "}bvt@Cƈړ`}bvt@C̒`v܂B");
            }

            for (int i = 0; i < maplist.Length - 1; i++)
            {
                MapDataFile mapdata = AddDataFile(maplist[i], chmaplist[i], mvmaplist[i]);

                if (Util.IsExist(mapdata.mapDataPath) == false)
                {
                    throw new FileNotFoundException("t@C " + mapdata.mapDataPath + " ܂B");
                }

                if (Util.IsExist(mapdata.chmapDataPath) == false)
                {
                    throw new FileNotFoundException("t@C " + mapdata.chmapDataPath + " ܂B");
                }

                if (Util.IsExist(mapdata.mvmapDataPath) == false)
                {
                    throw new FileNotFoundException("t@C " + mapdata.mvmapDataPath + " ܂B");
                }
            }
        }

        public void ReadExMapFiles(string mapdir, string mapsdir,
            string exmap, string exchmap, string exmvmap)
        {
            mapdir = exmaproot + "/" + mapdir;
            mapsdir = mapdir + "/" + mapsdir;

            exmap = mapdir + "/" + exmap;
            exchmap = mapdir + "/" + exchmap;
            exmvmap = mapdir + "/" + exmvmap;

            if (Util.IsExist(exmap) == false)
            {
                throw new FileNotFoundException("t@C " + exmap + " ܂B");
            }

            if (Util.IsExist(exchmap) == false)
            {
                throw new FileNotFoundException("t@C " + exchmap + " ܂B");
            }

            if (Util.IsExist(exmvmap) == false)
            {
                throw new FileNotFoundException("t@C " + exmvmap + " ܂B");
            }
            byte[] buff;

            buff = FileSys.Read(exmap);

            string[] maplist = Util.CnvByteArrayToStr(buff).Split("\n".ToCharArray());

            buff = FileSys.Read(exchmap);

            string[] chmaplist = Util.CnvByteArrayToStr(buff).Split("\n".ToCharArray());

            buff = FileSys.Read(exmvmap);

            string[] mvmaplist = Util.CnvByteArrayToStr(buff).Split("\n".ToCharArray());

            if (maplist.Length != chmaplist.Length)
            {
                throw new CornerCrashException(this, System.Reflection.MethodBase.GetCurrentMethod(),
                    "}bvt@CƃLN^[}bvt@C̒`v܂B");
            }

            if (maplist.Length != mvmaplist.Length)
            {
                throw new CornerCrashException(this, System.Reflection.MethodBase.GetCurrentMethod(),
                    "}bvt@Cƈړ`}bvt@C̒`v܂B");
            }

            for (int i = 0; i < maplist.Length - 1; i++)
            {
                MapDataFile mapdata = AddDataFile(mapsdir, maplist[i], chmaplist[i], mvmaplist[i]);

                if (Util.IsExist(mapdata.mapDataPath) == false)
                {
                    throw new FileNotFoundException("t@C " + mapdata.mapDataPath + " ܂B");
                }

                if (Util.IsExist(mapdata.chmapDataPath) == false)
                {
                    throw new FileNotFoundException("t@C " + mapdata.chmapDataPath + " ܂B");
                }

                if (Util.IsExist(mapdata.mvmapDataPath) == false)
                {
                    throw new FileNotFoundException("t@C " + mapdata.mvmapDataPath + " ܂B");
                }
            }
        }

        public MapDataFile AddDataFile(string mapdatapath, string chdatapath, string mvdatapath)
        {
            MapDataFile mapdata = new MapDataFile(basepath, mapdatapath, chdatapath, mvdatapath);
            datafiles.Add(mapdata);
            return mapdata;
        }

        public MapDataFile AddDataFile(string mapdir, string mapdatapath, string chdatapath, string mvdatapath)
        {
            MapDataFile mapdata = new MapDataFile(basepath, mapdatapath, chdatapath, mvdatapath);
            datafiles.Add(mapdata);
            return mapdata;
        }

        public MapDataFile this[int i]
        {
            get
            {
                return datafiles[i];
            }
        }

        public int MapCount
        {
            get
            {
                return datafiles.Count;
            }
        }
    }
}
