using System;
using System.Collections.Generic;
using System.Text;

using YD = Yanesdk.Draw;

namespace CornerCrash
{
    class OnyanokoBase : ComCharacter
    {                
        enum addPoint
        {
            DEFAULT = 100,
        }

        enum spTimeCnt
        {
            CASEBACK = 30,
            MIN = 150,
            HIGHPNT = 600,
            MIDDLEPNT = 1200,
            LOWPNT = 2100,
        }

        protected int noPointTimeCnt;
        protected int SpeciaPointlTimeCnt;
        protected bool IsSpecialPoint;
        protected int addpoint;
        protected int fleecnt;
        protected int stopinterval;

        protected const int stopIntervalMax = 3;
        protected const int fleeCntMax = 50;
        protected int attackTime;
        protected const int attackTimeMax = 150;

        protected int[] speed = {
            10,6,4,2,0,
        };

        enum speedMode
        {
            ATTACK = 0,
            FLEE,
            DEFAULT,
            LOW,
            STOP,
        }

        private int spmodex;
        private int spmodey;

        protected OnyanokoBase()
        {

        }

        public OnyanokoBase(YD.Screen2DGl pscreen, BGMap pMap)
            : base(pscreen, pMap)
        {
            spmodex = speed.Length - 1;
            spmodey = speed.Length - 1;
            noPointTimeCnt = 0;
            IsSpecialPoint = false;
            SpeciaPointlTimeCnt = 0;
            addpoint = (int)addPoint.DEFAULT;
            nowdirect = NowDirection.BOTTOM;
            stopinterval = 0;
            fleecnt = 0;
            visionw = BGMap.MAPCHIP_WIDTH / 2;
            attackTime = 0;
        }

        public override void LoadSprite()
        {
            textureList = OnyanokoTexture.getInstance(ImageDir).TextureList;
            sprite = new BaseSprite(screen, textureList[(int)OnyanokoTexture.TEXTURE.BOTTOM]);
            beforeDirection = (int)OnyanokoTexture.TEXTURE.BOTTOM;
        }

        public override void Control()
        {
            if (player == null)
            {
                foreach (Character charp in characters)
                {
                    if (charp.CharType == CornerCrashDefine.characterType.Player)
                    {
                        player = charp;
                        break;
                    }
                }
            }
            int move = movernd.Next();
            NowDirection movedirect = NowDirection.VOID;

            move = move % 100;

            int disstance = MonitoringPlayer(nowdirect);

            if ((disstance >= 0) && (disstance < (CornerCrashDefine.CHAR_DISTANCE_BASE * 3)) &&
                (fleecnt == 0) && (attackTime <= 0))
            {
                stopinterval = stopIntervalMax;
                fleecnt = fleeCntMax;
            }

            if (fleecnt > 0)
            {
                if (stopinterval == 0)
                {
                    movedirect = getBackDirection(nowdirect);
                }
            }

            if ((movewait == 0) && (fleecnt == 0))
            {
                if ((NextMapDirect != NowDirection.VOID) && (move <= 90))
                {
                    movedirect = NextMapDirect;
                }
                else
                {
                    movedirect = ConvDirection(move % 5);
                }
                movewait = 30;
            }

            movewait--;

            if (movewait < 0)
            {
                movewait = 0;
            }

            if (movedirect == NowDirection.VOID)
            {
                movedirect = nowdirect;
            }

            if (attackTime > 0)
            {
                attackTime--;
                if (attackTime < 0)
                {
                    attackTime = 0;
                }
                movedirect = ChasePlayer();
            }

            nowdirect = movedirect;

            setSpeedMode();

            switch (movedirect)
            {
                case NowDirection.TOP:
                    decAnimInterval();
                    MoveToTop();
                    break;
                case NowDirection.BOTTOM:
                    decAnimInterval();
                    MoveToBottom();
                    break;
                case NowDirection.LEFT:
                    decAnimInterval();
                    MoveToLeft();
                    break;
                case NowDirection.RIGHT:
                    decAnimInterval();
                    MoveToRight();
                    break;
                default:
                    MoveNothing();
                    break;
            }
            chkHitPlayer();

            noPointTimeCnt--;
            if (noPointTimeCnt < 0)
            {
                noPointTimeCnt = 0;
            }

            if (IsSpecialPoint == true)
            {
                if (++SpeciaPointlTimeCnt > (int)spTimeCnt.LOWPNT)
                {
                    IsSpecialPoint = false;
                }
            }

            if ((fleecnt > 0) && (stopinterval == 0))
            {
                fleecnt--;
            }

            if (fleecnt == 0)
            {
                stopinterval = 0;
            }

            if (CurPosOfBGType == BGMap.BGType.GOAL)
            {
                isvalid = false;
            }
            stopinterval--;
        }

        protected override Character.NowDirection ConvDirection(int move)
        {
            NowDirection direct = base.ConvDirection(move);
            if ((direct == NowDirection.NOTHING) || (direct == NowDirection.VOID))
            {
                direct = nowdirect;
            }

            return direct;
        }

        protected bool IsChangeDirection(OnyanokoTexture.TEXTURE now)
        {
            return OnyanokoTexture.IsChangeDirection(now, beforeDirection, ImageDir);
        }

        private void MoveToTop()
        {
            if ((animinterval <= 0) || (IsChangeDirection(OnyanokoTexture.TEXTURE.TOP) == true))
            {
                if (backmvstate == BackMoveSt.MoveR)
                {
                    sprite.setTexture(textureList[(int)OnyanokoTexture.TEXTURE.TOP2]);
                    beforeDirection = (int)OnyanokoTexture.TEXTURE.TOP2;
                    backmvstate = BackMoveSt.MoveL;
                }
                else
                {
                    sprite.setTexture(textureList[(int)OnyanokoTexture.TEXTURE.TOP1]);
                    beforeDirection = (int)OnyanokoTexture.TEXTURE.TOP1;
                    backmvstate = BackMoveSt.MoveR;
                }
                animinterval = animintervalmax;
            }
            nowdirect = NowDirection.TOP;
            if (IsYMove(false) == false)
            {
                isturn = false;
                fleecnt = 0;
                movewait = 0;
                return;
            }
            y -= my;
        }

        private void MoveToBottom()
        {
            if ((animinterval <= 0) || (IsChangeDirection(OnyanokoTexture.TEXTURE.BOTTOM) == true))
            {
                if (backmvstate == BackMoveSt.MoveR)
                {
                    sprite.setTexture(textureList[(int)OnyanokoTexture.TEXTURE.BOTTOM2]);
                    beforeDirection = (int)OnyanokoTexture.TEXTURE.BOTTOM2;
                    backmvstate = BackMoveSt.MoveL;
                }
                else
                {
                    sprite.setTexture(textureList[(int)OnyanokoTexture.TEXTURE.BOTTOM1]);
                    beforeDirection = (int)OnyanokoTexture.TEXTURE.BOTTOM1;
                    backmvstate = BackMoveSt.MoveR;
                }
                animinterval = animintervalmax;
            }
            nowdirect = NowDirection.BOTTOM;
            if (IsYMove(true) == false)
            {
                isturn = false;
                fleecnt = 0;
                movewait = 0;
                return;
            }
            y += my;
        }


        private void MoveToLeft()
        {
            if ((animinterval <= 0) || (IsChangeDirection(OnyanokoTexture.TEXTURE.LEFT) == true))
            {
                if (backmvstate == BackMoveSt.MoveR)
                {
                    sprite.setTexture(textureList[(int)OnyanokoTexture.TEXTURE.LEFT2]);
                    beforeDirection = (int)OnyanokoTexture.TEXTURE.LEFT2;
                    backmvstate = BackMoveSt.MoveL;
                }
                else
                {
                    sprite.setTexture(textureList[(int)OnyanokoTexture.TEXTURE.LEFT1]);
                    beforeDirection = (int)OnyanokoTexture.TEXTURE.LEFT1;
                    backmvstate = BackMoveSt.MoveR;
                }
                animinterval = animintervalmax;
            }
            nowdirect = NowDirection.LEFT;
            if (IsXMove(false) == false)
            {
                isturn = false;
                fleecnt = 0;
                movewait = 0;
                return;
            }
            x -= mx;
        }

        private void MoveToRight()
        {
            if ((animinterval <= 0) || (IsChangeDirection(OnyanokoTexture.TEXTURE.RIGHT) == true))
            {
                if (backmvstate == BackMoveSt.MoveR)
                {
                    sprite.setTexture(textureList[(int)OnyanokoTexture.TEXTURE.RIGHT2]);
                    beforeDirection = (int)OnyanokoTexture.TEXTURE.RIGHT2;
                    backmvstate = BackMoveSt.MoveL;
                }
                else
                {
                    sprite.setTexture(textureList[(int)OnyanokoTexture.TEXTURE.RIGHT1]);
                    beforeDirection = (int)OnyanokoTexture.TEXTURE.RIGHT1;
                    backmvstate = BackMoveSt.MoveR;
                }
                animinterval = animintervalmax;
            }
            nowdirect = NowDirection.RIGHT;
            if (IsXMove(true) == false)
            {
                isturn = false;
                fleecnt = 0;
                movewait = 0;
                return;
            }
            x += mx;
        }

        private void MoveNothing()
        {
            backmvstate = BackMoveSt.NoMove;

            switch (beforeDirection)
            {
                case (int)OnyanokoTexture.TEXTURE.TOP1:
                    beforeDirection = (int)OnyanokoTexture.TEXTURE.TOP;
                    break;

                case (int)OnyanokoTexture.TEXTURE.TOP2:
                    beforeDirection = (int)OnyanokoTexture.TEXTURE.TOP2;
                    break;

                case (int)OnyanokoTexture.TEXTURE.RIGHT1:
                    beforeDirection = (int)OnyanokoTexture.TEXTURE.RIGHT;
                    break;

                case (int)OnyanokoTexture.TEXTURE.RIGHT2:
                    beforeDirection = (int)OnyanokoTexture.TEXTURE.RIGHT;
                    break;

                case (int)OnyanokoTexture.TEXTURE.LEFT1:
                    beforeDirection = (int)OnyanokoTexture.TEXTURE.LEFT;
                    break;

                case (int)OnyanokoTexture.TEXTURE.LEFT2:
                    beforeDirection = (int)OnyanokoTexture.TEXTURE.LEFT;
                    break;

                case (int)OnyanokoTexture.TEXTURE.BOTTOM1:
                    beforeDirection = (int)OnyanokoTexture.TEXTURE.BOTTOM;
                    break;

                case (int)OnyanokoTexture.TEXTURE.BOTTOM2:
                    beforeDirection = (int)OnyanokoTexture.TEXTURE.BOTTOM;
                    break;
                default:
                    break;
            }
            sprite.setTexture(textureList[beforeDirection]);
        }

        private void setSpeedMode()
        {
            if (attackTime > 0)
            {
                spmodex = (int)speedMode.ATTACK;
                spmodey = (int)speedMode.ATTACK;
            }
            else if (fleecnt > 0)
            {
                if (stopinterval > ((stopIntervalMax / 3) * 2))
                {
                    spmodex = (int)speedMode.LOW;
                    spmodey = (int)speedMode.LOW;
                }
                else if (stopinterval > (stopIntervalMax / 3))
                {
                    spmodex = (int)speedMode.STOP;
                    spmodey = (int)speedMode.STOP;
                }
                else if (stopinterval <= 0)
                {
                    spmodex = (int)speedMode.FLEE;
                    spmodey = (int)speedMode.FLEE;
                }
            }
            else
            {
                spmodex = (int)speedMode.DEFAULT;
                spmodey = (int)speedMode.DEFAULT;
            }

            if ((spmodex > speed.Length - 1) || (spmodey > speed.Length - 1))
            {
                throw new CornerCrashException(this, System.Reflection.MethodBase.GetCurrentMethod(),
                    "speedmode̒l͈͊OłB");
            }

            mx = speed[spmodex];
            my = speed[spmodey];
        }

        protected override int MonitoringPlayer(NowDirection Direction)
        {
            switch (Direction)
            {
                case NowDirection.TOP:
                    if (Math.Abs(x - player.x) < (visionw / 2))
                    {
                        return ((y - player.y) - player.sprite.height);
                    }
                    break;
                case NowDirection.BOTTOM:
                    if (Math.Abs(x - player.x) < (visionw / 2))
                    {
                        return (-(y - player.y) - sprite.height);
                    }
                    break;
                case NowDirection.LEFT:
                    if (Math.Abs(y - player.y) < (visionw / 2))
                    {
                        return ((x - player.x) - player.sprite.width);
                    }
                    break;
                case NowDirection.RIGHT:
                    if (Math.Abs(y - player.y) < (visionw / 2))
                    {
                        return (-(x - player.x) - sprite.width);
                    }
                    break;
                default:
                    break;
            }
            return -1;
        }

        protected virtual void chkHitPlayer()
        {
            if (chkIsinBoxArea(player.x, player.y,
               player.sprite.width, player.sprite.height) == true)
            {
                if (noPointTimeCnt > 0)
                {
                    return;
                }

                string eventkey = null;
                if (attackTime > 0)
                {
                    LimitTimes.getInstance().DecCurTime(1);
                    noPointTimeCnt = (int)spTimeCnt.CASEBACK;
                    EffectLayer.getInstance().ExecRequest(Effect.EffectType.DEFAULT);
                    return;
                }

                if (nowdirect == player.NowDirect)
                {
                    eventkey = HitEvtDefTbl.getInstance().EventSearch(UniqCharType, true);

                    if (eventkey == null)
                    {
                        eventkey = HimeiEvtKey;
                    }

                    GameEventMng.getInstance().EventExecRequest(eventkey);
                    GameEventMng.getInstance().incBackHitcounter(UniqCharType);
                    player.negGamePoint(1000);
                    noPointTimeCnt = (int)spTimeCnt.CASEBACK;
                    attackTime = attackTimeMax;
                    nowdirect = getBackDirection(nowdirect);
                    return;
                }

                switch (nowdirect)
                {
                    case NowDirection.TOP:
                        if (((y + sprite.height / 2) > player.y) == false)
                        {
                            return;
                        }
                        break;
                    case NowDirection.BOTTOM:
                        if (((y - sprite.height / 2) < player.y) == false)
                        {
                            return;
                        }
                        break;
                    case NowDirection.LEFT:
                        if (((x + sprite.width / 2) > player.x) == false)
                        {
                            return;
                        }
                        break;
                    case NowDirection.RIGHT:
                        if (((x - sprite.width / 2) < player.x) == false)
                        {
                            return;
                        }
                        break;
                    default:
                        return;
                }

                if ((CurPosOfBGType != BGMap.BGType.CORNER) &&
                   (CurPosOfBGType != BGMap.BGType.TJIRO) &&
                   (CurPosOfBGType != BGMap.BGType.JYUJIRO))
                {
                    return;
                }

                noPointTimeCnt = (int)spTimeCnt.MIN;
                IsSpecialPoint = true;
                if (SpeciaPointlTimeCnt <= (int)spTimeCnt.HIGHPNT)
                {
                    addpoint += (int)addPoint.DEFAULT * 5;
                }
                else if (SpeciaPointlTimeCnt <= (int)spTimeCnt.MIDDLEPNT)
                {
                    addpoint += (int)addPoint.DEFAULT * 2;
                }
                else if (SpeciaPointlTimeCnt <= (int)spTimeCnt.LOWPNT)
                {
                    addpoint += (int)addPoint.DEFAULT;
                }
                else
                {
                    addpoint = (int)addPoint.DEFAULT;
                }

                eventkey = HitEvtDefTbl.getInstance().EventSearch(UniqCharType, false);
                GameEventMng.getInstance().charHitNotice(UniqCharType);
                if (eventkey == null)
                {
                    GameEventMng.getInstance().EventExecRequest(DefaultEvtKey);
                }
                else
                {
                    GameEventMng.getInstance().EventExecRequest(eventkey);
                }

                player.addGamePoint(addpoint);
                SpeciaPointlTimeCnt = 0;
            }
        }

        public override void drawIcon()
        {
            if (noPointTimeCnt > 0)
            {
                screen.Blt(textureList[(int)OnyanokoTexture.TEXTURE.HITICON], sprite.x, sprite.y);
            }
        }

        public override CornerCrashDefine.characterType CharType
        {
            get
            {
                return CornerCrashDefine.characterType.Onyanoko;
            }
        }

        protected virtual string ImageDir
        {
            get
            {
                return "charimg/onyanoko1";
            }
        }

        protected virtual string DefaultEvtKey
        {
            get
            {
                return "onyanoko";
            }
        }

        protected virtual string HimeiEvtKey
        {
            get
            {
                return "himei";
            }
        }
    }
}
