using System;
using System.Collections.Generic;
using System.Text;

using YD = Yanesdk.Draw;

namespace CornerCrash
{
    class Police : ComCharacter
    {
        enum xySwitch
        {
            x = 0,
            y
        }

        enum noHitTime
        {
            DEFAULT = 30,
        }

        protected int noHitTimeCnt;
        protected int ChaseTime;
        protected const int ChaseTimeMax = 150;

        protected const int stopIntervalMax = 3;

        enum speedMode
        {
            DEFAULT = 0,
            CHASE,
        }

        protected int[] speed = {
            3,8,
        };

        protected int spmodex;
        protected int spmodey;


        public Police(YD.Screen2DGl pscreen, BGMap pMap)
            : base(pscreen, pMap)
        {
            mx = 6;
            my = 6;
            ChaseTime = 0;
        }
        
        public override void LoadSprite()
        {
            textureList = PoliceTexture.getInstance().TextureList;
            sprite = new BaseSprite(screen, textureList[(int)PoliceTexture.TEXTURE.BOTTOM]);
            beforeDirection = (int)PoliceTexture.TEXTURE.BOTTOM;
        }

        public override void Control()
        {
            if (player == null)
            {
                foreach (Character charp in characters)
                {
                    if (charp.CharType == CornerCrashDefine.characterType.Player)
                    {
                        player = charp;
                        break;
                    }
                }
            }


            int move = movernd.Next();

            move = move % 30;

            NowDirection movedirect = ConvDirection(move);

            int disstance = MonitoringPlayer(nowdirect);

            /*
            if ((disstance >= 0) && (disstance < (CornerCrashDefine.CHAR_DISTANCE_BASE * 5)) && (ChaseTime <= 0))
            {
                ChaseTime = ChaseTimeMax;
            }

            if(ChaseTime > 0)
            {
                ChaseTime--;
                if(ChaseTime < 0)
                {
                    ChaseTime = 0;
                }
                movedirect = ChasePlayer();
            }
            */

            setSpeedMode();

            switch (movedirect)
            {
                case NowDirection.TOP:
                    decAnimInterval();
                    MoveToTop();
                    break;
                case NowDirection.BOTTOM:
                    decAnimInterval();
                    MoveToBottom();
                    break;
                case NowDirection.LEFT:
                    decAnimInterval();
                    MoveToLeft();
                    break;
                case NowDirection.RIGHT:
                    decAnimInterval();
                    MoveToRight();
                    break;
                default:
                    MoveNothing();
                    break;
            }
            chkHitChar();
            nowdirect = movedirect;
        }

        protected override Character.NowDirection ConvDirection(int move)
        {
            if (move > 3)
            {
                return nowdirect;
            }

            NowDirection direct = base.ConvDirection(move);
            return direct;
        }

        protected override bool IsXMove(bool isadd)
        {
            if (base.IsXMove(isadd) == false)
            {
                return false;
            }

            return true;
        }

        protected override bool IsYMove(bool isadd)
        {
            if (base.IsYMove(isadd) == false)
            {
                return false;
            }

            return true;
        }

        protected void setSpeedMode()
        {
            if (ChaseTime > 0)
            {
                spmodex = (int)speedMode.CHASE;
                spmodey = (int)speedMode.CHASE;
            }
            else
            {
                spmodex = (int)speedMode.DEFAULT;
                spmodey = (int)speedMode.DEFAULT;
            }


            if (spmodex > speed.Length - 1)
            {
                spmodex = speed.Length - 1;
            }

            if (spmodey > speed.Length - 1)
            {
                spmodey = speed.Length - 1;
            }

            mx = speed[spmodex];
            my = speed[spmodey];
        }

        protected override int MonitoringPlayer(NowDirection Direction)
        {
            switch (Direction)
            {
                case NowDirection.TOP:
                    if (Math.Abs(x - player.x) < (visionw / 2))
                    {
                        return ((y - player.y) - player.sprite.height);
                    }
                    break;
                case NowDirection.BOTTOM:
                    if (Math.Abs(x - player.x) < (visionw / 2))
                    {
                        return (-(y - player.y) - sprite.height);
                    }
                    break;
                case NowDirection.LEFT:
                    if (Math.Abs(y - player.y) < (visionw / 2))
                    {
                        return ((x - player.x) - player.sprite.width);
                    }
                    break;
                case NowDirection.RIGHT:
                    if (Math.Abs(y - player.y) < (visionw / 2))
                    {
                        return (-(x - player.x) - sprite.width);
                    }
                    break;
                default:
                    break;
            }
            return -1;
        }

        protected void chkHitChar()
        {
            List<Character> hitchars;
            chkIsinBoxAreaNextPos(x, y, out hitchars);

            foreach (Character charp in hitchars)
            {

                if ((charp.CharType == CornerCrashDefine.characterType.Player) &&
                     (noHitTimeCnt == 0))
                {
                    string eventkey = HitEvtDefTbl.getInstance().EventSearch(UniqCharType, false);
                    if (eventkey == null)
                    {
                        GameEventMng.getInstance().PoliceHitEventExec();
                    }
                    else
                    {
                        GameEventMng.getInstance().EventExecRequest(eventkey);
                    }
                    GameEventMng.getInstance().charHitNotice(CharType);
                    noHitTimeCnt = (int)noHitTime.DEFAULT;
                }

                noHitTimeCnt--;
                if (noHitTimeCnt < 0)
                {
                    noHitTimeCnt = 0;
                }
            }
        }

        protected void chkIsinBoxAreaNextPos(int chkx, int chky, out List<Character> hitchars)
        {
            hitchars = new List<Character>();
            for (int i = 0; i < characters.Count; i++)
            {
                if (characters[i] == this)
                {
                    continue;
                }

                if (characters[i].chkIsinBoxArea(chkx, chky, sprite.width, sprite.height) == true)
                {
                    hitchars.Add(characters[i]);
                }
            }
        }

        protected bool IsChangeDirection(PoliceTexture.TEXTURE now)
        {
            return PoliceTexture.IsChangeDirection(now, beforeDirection);
        }

        protected void MoveToTop()
        {
            if ((animinterval <= 0) || (IsChangeDirection(PoliceTexture.TEXTURE.TOP) == true))
            {
                if (backmvstate == BackMoveSt.MoveR)
                {
                    sprite.setTexture(textureList[(int)PoliceTexture.TEXTURE.TOP2]);
                    beforeDirection = (int)PoliceTexture.TEXTURE.TOP2;
                    backmvstate = BackMoveSt.MoveL;
                }
                else
                {
                    sprite.setTexture(textureList[(int)PoliceTexture.TEXTURE.TOP1]);
                    beforeDirection = (int)PoliceTexture.TEXTURE.TOP1;
                    backmvstate = BackMoveSt.MoveR;
                }
                animinterval = animintervalmax;
            }

            if (IsYMove(false) == false)
            {
                return;
            }
            y -= my;
        }

        protected void MoveToBottom()
        {
            if ((animinterval <= 0) || (IsChangeDirection(PoliceTexture.TEXTURE.BOTTOM) == true))
            {
                if (backmvstate == BackMoveSt.MoveR)
                {
                    sprite.setTexture(textureList[(int)PoliceTexture.TEXTURE.BOTTOM2]);
                    beforeDirection = (int)PoliceTexture.TEXTURE.BOTTOM2;
                    backmvstate = BackMoveSt.MoveL;
                }
                else
                {
                    sprite.setTexture(textureList[(int)PoliceTexture.TEXTURE.BOTTOM1]);
                    beforeDirection = (int)PoliceTexture.TEXTURE.BOTTOM1;
                    backmvstate = BackMoveSt.MoveR;
                }
                animinterval = animintervalmax;
            }

            if (IsYMove(true) == false)
            {
                return;
            }
            y += my;
        }


        protected void MoveToLeft()
        {
            if ((animinterval <= 0) || (IsChangeDirection(PoliceTexture.TEXTURE.LEFT) == true))
            {
                if (backmvstate == BackMoveSt.MoveR)
                {
                    sprite.setTexture(textureList[(int)PoliceTexture.TEXTURE.LEFT2]);
                    beforeDirection = (int)PoliceTexture.TEXTURE.LEFT2;
                    backmvstate = BackMoveSt.MoveL;
                }
                else
                {
                    sprite.setTexture(textureList[(int)PoliceTexture.TEXTURE.LEFT1]);
                    beforeDirection = (int)PoliceTexture.TEXTURE.LEFT1;
                    backmvstate = BackMoveSt.MoveR;
                }
                animinterval = animintervalmax;
            }

            if (IsXMove(false) == false)
            {
                return;
            }
            x -= mx;
        }

        protected void MoveToRight()
        {
            if ((animinterval <= 0) || (IsChangeDirection(PoliceTexture.TEXTURE.RIGHT) == true))
            {
                if (backmvstate == BackMoveSt.MoveR)
                {
                    sprite.setTexture(textureList[(int)PoliceTexture.TEXTURE.RIGHT2]);
                    beforeDirection = (int)PoliceTexture.TEXTURE.RIGHT2;
                    backmvstate = BackMoveSt.MoveL;
                }
                else
                {
                    sprite.setTexture(textureList[(int)PoliceTexture.TEXTURE.RIGHT1]);
                    beforeDirection = (int)PoliceTexture.TEXTURE.RIGHT1;
                    backmvstate = BackMoveSt.MoveR;
                }
                animinterval = animintervalmax;
            }

            if (IsXMove(true) == false)
            {
                return;
            }
            x += mx;
        }

        protected void MoveNothing()
        {
            backmvstate = BackMoveSt.NoMove;

            switch (beforeDirection)
            {
                case (int)PoliceTexture.TEXTURE.TOP1:
                    beforeDirection = (int)PoliceTexture.TEXTURE.TOP;
                    break;

                case (int)PoliceTexture.TEXTURE.TOP2:
                    beforeDirection = (int)PoliceTexture.TEXTURE.TOP2;
                    break;

                case (int)PoliceTexture.TEXTURE.RIGHT1:
                    beforeDirection = (int)PoliceTexture.TEXTURE.RIGHT;
                    break;

                case (int)PoliceTexture.TEXTURE.RIGHT2:
                    beforeDirection = (int)PoliceTexture.TEXTURE.RIGHT;
                    break;

                case (int)PoliceTexture.TEXTURE.LEFT1:
                    beforeDirection = (int)PoliceTexture.TEXTURE.LEFT;
                    break;

                case (int)PoliceTexture.TEXTURE.LEFT2:
                    beforeDirection = (int)PoliceTexture.TEXTURE.LEFT;
                    break;

                case (int)PoliceTexture.TEXTURE.BOTTOM1:
                    beforeDirection = (int)PoliceTexture.TEXTURE.BOTTOM;
                    break;

                case (int)PoliceTexture.TEXTURE.BOTTOM2:
                    beforeDirection = (int)PoliceTexture.TEXTURE.BOTTOM;
                    break;
                default:
                    break;
            }
            sprite.setTexture(textureList[beforeDirection]);
        }

        public override CornerCrashDefine.characterType CharType
        {
            get
            {
                return CornerCrashDefine.characterType.Police;
            }
        }
    }
}
