using System;
using System.Collections.Generic;
using System.Text;

using System.Drawing;
using Yanesdk.System;

namespace CornerCrash
{
    class PoliceTexture : CharacterTexture
    {
        private const string icondir = "charimg/icon";
        protected static PoliceTexture instance;

        public new enum TEXTURE
        {
            BOTTOM = 0,
            BOTTOM2,
            BOTTOM1,
            LEFT,
            LEFT2,
            LEFT1,
            TOP,
            TOP2,
            TOP1,
            RIGHT,
            RIGHT2,
            RIGHT1,
            MAX,
        }


        public static PoliceTexture getInstance()
        {
            string imgdir = "charimg/police";

            if (instance != null)
            {
                return instance;
            }

            instance = new PoliceTexture();
            instance.Load(imgdir);

            return instance;
        }

        protected void Load(string imgdir)
        {
            textureList = new Yanesdk.Draw.GlTexture[(int)TEXTURE.MAX];
            textureList[(int)TEXTURE.TOP] = new Yanesdk.Draw.GlTexture();
            textureList[(int)TEXTURE.TOP1] = new Yanesdk.Draw.GlTexture();
            textureList[(int)TEXTURE.TOP2] = new Yanesdk.Draw.GlTexture();
            textureList[(int)TEXTURE.BOTTOM] = new Yanesdk.Draw.GlTexture();
            textureList[(int)TEXTURE.BOTTOM1] = new Yanesdk.Draw.GlTexture();
            textureList[(int)TEXTURE.BOTTOM2] = new Yanesdk.Draw.GlTexture();
            textureList[(int)TEXTURE.LEFT] = new Yanesdk.Draw.GlTexture();
            textureList[(int)TEXTURE.LEFT1] = new Yanesdk.Draw.GlTexture();
            textureList[(int)TEXTURE.LEFT2] = new Yanesdk.Draw.GlTexture();
            textureList[(int)TEXTURE.RIGHT] = new Yanesdk.Draw.GlTexture();
            textureList[(int)TEXTURE.RIGHT1] = new Yanesdk.Draw.GlTexture();
            textureList[(int)TEXTURE.RIGHT2] = new Yanesdk.Draw.GlTexture();

            if (Util.IsExist(imgdir + "/" + "fullset.gif") == true)
            {
                LoadFromBMP(imgdir);
            }
            else
            {
                LoadFromFile(imgdir);
            }
        }

        public static bool IsChangeDirection(TEXTURE now, int past)
        {
            return instance.IsChangeDirection((int)now, past);
        }

        protected void LoadFromFile(string imgdir)
        {
            textureList[(int)TEXTURE.TOP].Load(imgdir + "/" + "top.gif");
            textureList[(int)TEXTURE.TOP1].Load(imgdir + "/" + "top1.gif");
            textureList[(int)TEXTURE.TOP2].Load(imgdir + "/" + "top2.gif");
            textureList[(int)TEXTURE.BOTTOM].Load(imgdir + "/" + "bottom.gif");
            textureList[(int)TEXTURE.BOTTOM1].Load(imgdir + "/" + "bottom1.gif");
            textureList[(int)TEXTURE.BOTTOM2].Load(imgdir + "/" + "bottom2.gif");
            textureList[(int)TEXTURE.LEFT].Load(imgdir + "/" + "left.gif");
            textureList[(int)TEXTURE.LEFT1].Load(imgdir + "/" + "left1.gif");
            textureList[(int)TEXTURE.LEFT2].Load(imgdir + "/" + "left2.gif");
            textureList[(int)TEXTURE.RIGHT].Load(imgdir + "/" + "right.gif");
            textureList[(int)TEXTURE.RIGHT1].Load(imgdir + "/" + "right1.gif");
            textureList[(int)TEXTURE.RIGHT2].Load(imgdir + "/" + "right2.gif");
        }

        protected void LoadFromBMP(string imgdir)
        {
            Bitmap TextureBMP = Util.LoadBmp(imgdir + "/" + "fullset.gif");
            int width = TextureBMP.Width / 3;
            int height = TextureBMP.Height / 4;

            Bitmap Bmpbuff = null;
            Graphics g = null;
            Rectangle dstrect = new Rectangle(0, 0, width, height);

            for (int y = 0; y < 4; y++)
            {
                for (int x = 0; x < 3; x++)
                {
                    Bmpbuff = new Bitmap(width, height);
                    g = Graphics.FromImage(Bmpbuff);

                    g.DrawImage(TextureBMP, dstrect, x * width, y * height, width, height,
                        GraphicsUnit.Pixel);
                    textureList[(y * 3) + x].SetBitmap(Bmpbuff);
                    Bmpbuff.Dispose();
                    g.Dispose();
                }
            }
            System.GC.Collect(2);
        }
    }
}
