using System;
using System.Collections.Generic;
using System.Text;

namespace CornerCrash
{
    class SinarioTag
    {
        public class TagName
        {
            public const string section = "section";
            public const string endsection = "endsection";
            public const string nextstage = "nextstage";
            public const string transwait = "wt";
            public const string soundwait = "ws";
            public const string wait = "wait";
            public const string lf = "r";
            public const string image = "image";
            public const string clear = "clear";
            public const string copylay = "copylay";
            public const string fadein = "fadein";
            public const string fadeout = "fadeout";
            public const string inbgm = "fadeinbgm";
            public const string outbgm = "fadeoutbgm";
            public const string playbgm = "playbgm";
            public const string stopbgm = "stopbgm";
            public const string playsound = "playse";
            public const string stopsound = "stopse";
        }

        private class TagFunc
        {
            public static int Section(int index, string name, Dictionary<string, string> elm,
                ref CurrentSinario sinarioinfo, ref Stack<CurrentSinario> stack)
            {
                if (elm.ContainsKey("name") == false)
                {
                    throw new CornerCrashException(instance, System.Reflection.MethodBase.GetCurrentMethod(),
                        "ZNVݒ肳Ă܂B");
                }

                if (elm.ContainsKey("upflags") == true)
                {
                    string upflag = elm["upflags"];

                    upflag = upflag.Replace(" ", "");
                    upflag = upflag.Replace("\t", "");
                    upflag = upflag.Replace("\n", "");

                    string[] upflags = upflag.Split(Char.Parse(","));

                    if (FlagConditionTbl.getInstance().IsUpFlags(upflags) == false)
                    {
                        return  SinarioEngine.getInstance().findEndSection(index);
                    }
                }

                if (elm.ContainsKey("downflags") == true)
                {
                    string downflag = elm["downflags"];

                    downflag = downflag.Replace(" ", "");
                    downflag = downflag.Replace("\t", "");
                    downflag = downflag.Replace("\n", "");

                    string[] downflags = downflag.Split(Char.Parse(","));

                    if (FlagConditionTbl.getInstance().IsDownFlags(downflags) == false)
                    {
                        return SinarioEngine.getInstance().findEndSection(index);
                    }
                }

                sinarioinfo.pnt = SinarioEngine.getInstance().findEndSection(index);
                stack.Push(sinarioinfo);
                sinarioinfo.section = elm["name"];
                return index;
            }

            public static int EndSection(int index, string name, Dictionary<string, string> elm,
                ref CurrentSinario sinarioinfo, ref Stack<CurrentSinario> stack)
            {
                if (stack.Count == 0)
                {
                    throw new CornerCrashException(instance, System.Reflection.MethodBase.GetCurrentMethod(),
                        "ZNV" + sinarioinfo.section + "̖߂悪܂B");
                }

                sinarioinfo = stack.Pop();
                
                return index;
            }

            public static int NextStage(int index, string name, Dictionary<string, string> elm,
                ref CurrentSinario sinarioinfo, ref Stack<CurrentSinario> stack)
            {
                if (elm.ContainsKey("next") == false)
                {
                    sinarioinfo.pnt = index;
                    SinarioEngine.getInstance().Exit();
                    SinarioEngine.getInstance().SaveLayer();
                    return index;
                }

                string nextstr = elm["next"];

                int p = nextstr.IndexOf(":");
                string file = null;
                string section = null;

                if (p != -1)
                {
                    file = nextstr.Substring(0, p);

                    if (p >= (nextstr.Length - 1))
                    {
                        section = "";
                    }
                    else
                    {
                        section = nextstr.Substring(p + 1);
                    }
                }
                else
                {
                    section = nextstr;
                }

                if (file != null)
                {
                    sinarioinfo.file = file;
                }

                if (section != null)
                {
                    sinarioinfo.section = section;
                }

                stack.Clear();
                SinarioEngine.getInstance().LayerInit();
                index = SinarioEngine.getInstance().SectionInit();
                sinarioinfo.pnt = index;
                SinarioEngine.getInstance().Exit();

                return index;
            }

            public static int TransWait(int index, string name, Dictionary<string, string> elm,
                ref CurrentSinario sinarioinfo, ref Stack<CurrentSinario> stack)
            {
                SinarioEngine.getInstance().TransWait();

                return index;
            }

            public static int Wait(int index, string name, Dictionary<string, string> elm,
                ref CurrentSinario sinarioinfo, ref Stack<CurrentSinario> stack)
            {
                SinarioEngine.getInstance().Break();

                return index;
            }

            public static int LF(int index, string name, Dictionary<string, string> elm,
                ref CurrentSinario sinarioinfo, ref Stack<CurrentSinario> stack)
            {
                SinarioEngine.getInstance().SetLF();

                return index;
            }

            public static int LoadImage(int index, string name, Dictionary<string, string> elm,
                ref CurrentSinario sinarioinfo, ref Stack<CurrentSinario> stack)
            {
                if (elm.ContainsKey("storage") == false)
                {
                    throw new CornerCrashException(instance, System.Reflection.MethodBase.GetCurrentMethod(),
                        "t@Cw肳Ă܂B");
                }

                if (elm.ContainsKey("layer") == false)
                {
                    throw new CornerCrashException(instance, System.Reflection.MethodBase.GetCurrentMethod(),
                        "C[̂w肳Ă܂B");
                }

                string storage = elm["storage"];
                string layer = elm["layer"];

                SinarioEngine.Page page = SinarioEngine.Page.Fore;

                if (elm.ContainsKey("page") == true)
                {
                    if (elm["page"] == "back")
                    {
                        page = SinarioEngine.Page.Back;
                    }
                    else if (elm["page"] != "fore")
                    {
                        throw new CornerCrashException(instance, System.Reflection.MethodBase.GetCurrentMethod(),
                            "y[WɎw肳ꂽl" + elm["page"] + "͖`łB");
                    }
                }

                int x = 0;
                int y = 0;

                if (elm.ContainsKey("x") == true)
                {
                    try
                    {
                        x = int.Parse(elm["x"]);
                    }
                    catch (FormatException)
                    {
                        throw new CornerCrashException(instance, System.Reflection.MethodBase.GetCurrentMethod(),
                            "W x Ɏw肳ꂽl" + elm["x"] + "͕sȌ`łB");
                    }
                    catch (OverflowException)
                    {
                        throw new CornerCrashException(instance, System.Reflection.MethodBase.GetCurrentMethod(),
                            "W x Ɏw肳ꂽ" + elm["x"] + "͑傫lłB");
                    }
                }

                if (elm.ContainsKey("y") == true)
                {
                    try
                    {
                        y = int.Parse(elm["y"]);
                    }
                    catch (FormatException)
                    {
                        throw new CornerCrashException(instance, System.Reflection.MethodBase.GetCurrentMethod(),
                            "W x Ɏw肳ꂽl" + elm["y"] + "͕sȌ`łB");
                    }
                    catch (OverflowException)
                    {
                        throw new CornerCrashException(instance, System.Reflection.MethodBase.GetCurrentMethod(),
                            "W x Ɏw肳ꂽ" + elm["y"] + "͑傫lłB");
                    }
                }

                SinarioEngine.getInstance().LoadLayer(layer, storage, x, y, page);

                return index;
            }

            public static int ClearLayer(int index, string name, Dictionary<string, string> elm,
                ref CurrentSinario sinarioinfo, ref Stack<CurrentSinario> stack)
            {
                string layer = null;

                if (elm.ContainsKey("layer") == true)
                {
                    layer = elm["layer"];
                }

                SinarioEngine.Page page = SinarioEngine.Page.Fore;

                if (elm.ContainsKey("page") == true)
                {
                    if (elm["page"] == "back")
                    {
                        page = SinarioEngine.Page.Back;
                    }
                    else if (elm["page"] != "fore")
                    {
                        throw new CornerCrashException(instance, System.Reflection.MethodBase.GetCurrentMethod(),
                            "y[WɎw肳ꂽl" + elm["page"] + "͖`łB");
                    }
                }

                if (layer == null)
                {
                    SinarioEngine.getInstance().ClearLayers(page);
                }
                else
                {
                    SinarioEngine.getInstance().ClearLayer(layer, page);
                }

                return index;
            }

            public static int CopyLayer(int index, string name, Dictionary<string, string> elm,
                ref CurrentSinario sinarioinfo, ref Stack<CurrentSinario> stack)
            {
                SinarioEngine.Page page = SinarioEngine.Page.Fore;

                if (elm.ContainsKey("page") == true)
                {
                    if (elm["page"] == "back")
                    {
                        page = SinarioEngine.Page.Back;
                    }
                    else
                    {
                        throw new CornerCrashException(instance, System.Reflection.MethodBase.GetCurrentMethod(),
                            "y[WɎw肳ꂽl" + elm["page"] + "͖`łB");
                    }
                }

                SinarioEngine.getInstance().CopyLayer(page);

                return index;
            }

            public static int FadeInImage(int index, string name, Dictionary<string, string> elm,
                ref CurrentSinario sinarioinfo, ref Stack<CurrentSinario> stack)
            {
                int time = 1000;

                if (elm.ContainsKey("time") == true)
                {
                    try
                    {
                        time = int.Parse(elm["time"]);
                    }
                    catch (FormatException)
                    {
                        throw new CornerCrashException(instance, System.Reflection.MethodBase.GetCurrentMethod(),
                            "W x Ɏw肳ꂽl" + elm["time"] + "͕sȌ`łB");
                    }
                    catch (OverflowException)
                    {
                        throw new CornerCrashException(instance, System.Reflection.MethodBase.GetCurrentMethod(),
                            "W x Ɏw肳ꂽ" + elm["time"] + "͑傫lłB");
                    }
                }

                SinarioEngine.getInstance().FadeinRequest(time);

                return index;
            }

            public static int FadeOutImage(int index, string name, Dictionary<string, string> elm,
                ref CurrentSinario sinarioinfo, ref Stack<CurrentSinario> stack)
            {
                int time = 1000;

                if (elm.ContainsKey("time") == true)
                {
                    try
                    {
                        time = int.Parse(elm["time"]);
                    }
                    catch (FormatException)
                    {
                        throw new CornerCrashException(instance, System.Reflection.MethodBase.GetCurrentMethod(),
                            "W x Ɏw肳ꂽl" + elm["time"] + "͕sȌ`łB");
                    }
                    catch (OverflowException)
                    {
                        throw new CornerCrashException(instance, System.Reflection.MethodBase.GetCurrentMethod(),
                            "W x Ɏw肳ꂽ" + elm["time"] + "͑傫lłB");
                    }

                    SinarioEngine.getInstance().FadeoutRequest(time);
                }

                return index;
            }

            public static int FadeInBGM(int index, string name, Dictionary<string, string> elm,
                ref CurrentSinario sinarioinfo, ref Stack<CurrentSinario> stack)
            {
                if (elm.ContainsKey("storage") == false)
                {
                    throw new CornerCrashException(instance, System.Reflection.MethodBase.GetCurrentMethod(),
                        "BGMt@Cw肳Ă܂B");
                }

                string filename = elm["storage"];
                int time = 1000;

                if (elm.ContainsKey("time") == true)
                {
                    try
                    {
                        time = int.Parse(elm["time"]);
                    }
                    catch (FormatException)
                    {
                        throw new CornerCrashException(instance, System.Reflection.MethodBase.GetCurrentMethod(),
                            "w肳ꂽl" + elm["time"] + "͕sȌ`łB");
                    }
                    catch (OverflowException)
                    {
                        throw new CornerCrashException(instance, System.Reflection.MethodBase.GetCurrentMethod(),
                            "w肳ꂽ" + elm["time"] + "͑傫lłB");
                    }
                }

                if (time > 0)
                {
                    SinarioEngine.getInstance().InBGM(filename, time);
                }
                else
                {
                    SinarioEngine.getInstance().PlayBGM(filename);
                }

                return index;
            }

            public static int FadeOutBGM(int index, string name, Dictionary<string, string> elm,
                ref CurrentSinario sinarioinfo, ref Stack<CurrentSinario> stack)
            {
                int time = 1000;

                if (elm.ContainsKey("time") == true)
                {
                    try
                    {
                        time = int.Parse(elm["time"]);
                    }
                    catch (FormatException)
                    {
                        throw new CornerCrashException(instance, System.Reflection.MethodBase.GetCurrentMethod(),
                            "w肳ꂽl" + elm["time"] + "͕sȌ`łB");
                    }
                    catch (OverflowException)
                    {
                        throw new CornerCrashException(instance, System.Reflection.MethodBase.GetCurrentMethod(),
                            "w肳ꂽ" + elm["time"] + "͑傫lłB");
                    }
                }

                if (time > 0)
                {
                    SinarioEngine.getInstance().OutBGM(time);
                }
                else
                {
                    SinarioEngine.getInstance().StopBGM();
                }

                return index;
            }

            public static int PlayBGM(int index, string name, Dictionary<string, string> elm,
                ref CurrentSinario sinarioinfo, ref Stack<CurrentSinario> stack)
            {
                if (elm.ContainsKey("storage") == false)
                {
                    throw new CornerCrashException(instance, System.Reflection.MethodBase.GetCurrentMethod(),
                        "BGMt@Cw肳Ă܂B");
                }

                string filename = elm["storage"];

                SinarioEngine.getInstance().PlayBGM(filename);

                return index;
            }

            public static int StopBGM(int index, string name, Dictionary<string, string> elm,
                ref CurrentSinario sinarioinfo, ref Stack<CurrentSinario> stack)
            {
                SinarioEngine.getInstance().StopBGM();

                return index;
            }

            public static int PlaySE(int index, string name, Dictionary<string, string> elm,
                ref CurrentSinario sinarioinfo, ref Stack<CurrentSinario> stack)
            {
                if (elm.ContainsKey("storage") == false)
                {
                    throw new CornerCrashException(instance, System.Reflection.MethodBase.GetCurrentMethod(),
                        "SEt@Cw肳Ă܂B");
                }

                string filename = elm["storage"];

                SinarioEngine.getInstance().PlaySound(filename);

                return index;
            }

            public static int StopSE(int index, string name, Dictionary<string, string> elm,
                ref CurrentSinario sinarioinfo, ref Stack<CurrentSinario> stack)
            {
                SinarioEngine.getInstance().StopSound();

                return index;
            }

            public static int WaitSE(int index, string name, Dictionary<string, string> elm,
                ref CurrentSinario sinarioinfo, ref Stack<CurrentSinario> stack)
            {
                SinarioEngine.getInstance().SoundWait();

                return index;
            }
        }
        
        private static SinarioTag instance;

        private SinarioTag()
        {

        }

        private static void GenLoggerInstance()
        {
            if (instance == null)
            {
                instance = new SinarioTag();
            }
        }

        public static int findTagEnd(int i, string sinario)
        {
            GenLoggerInstance();

            int dqpnt = i;
            int etagpnt = i;

            for (; i < sinario.Length; i++)
            {
                dqpnt = sinario.IndexOf(SinarioEngine.dquote, i);
                etagpnt = sinario.IndexOf(SinarioEngine.etagch, i);

                if (etagpnt == -1)
                {
                    throw new CornerCrashException(instance, System.Reflection.MethodBase.GetCurrentMethod(),
                        "^OĂ܂B");
                }

                if ((dqpnt == -1) || (etagpnt < dqpnt))
                {
                    i = etagpnt;
                    break;
                }
                else
                {
                    i = dqpnt + 1;

                    for (; i < sinario.Length; i++)
                    {
                        if ((sinario[i] == SinarioEngine.dquote) && (sinario[i - 1] != SinarioEngine.escape))
                        {
                            break;
                        }
                    }
                }
            }

            return i;
        }

        public static int Exec(int index, string name, Dictionary<string, string> elm,
            ref CurrentSinario sinarioinfo, ref Stack<CurrentSinario> stack)
        {
            GenLoggerInstance();

            switch (name)
            {
                case TagName.section:
                    index = TagFunc.Section(index, name, elm, ref sinarioinfo, ref stack);
                    break;
                case TagName.endsection:
                    index = TagFunc.EndSection(index, name, elm, ref sinarioinfo, ref stack);
                    break;
                case TagName.transwait:
                    index = TagFunc.TransWait(index, name, elm, ref sinarioinfo, ref stack);
                    break;
                case TagName.wait:
                    index = TagFunc.Wait(index, name, elm, ref sinarioinfo, ref stack);
                    break;
                case TagName.lf:
                    index = TagFunc.LF(index, name, elm, ref sinarioinfo, ref stack);
                    break;
                case TagName.image:
                    index = TagFunc.LoadImage(index, name, elm, ref sinarioinfo, ref stack);
                    break;
                case TagName.clear:
                    index = TagFunc.ClearLayer(index, name, elm, ref sinarioinfo, ref stack);
                    break;
                case TagName.copylay:
                    index = TagFunc.CopyLayer(index, name, elm, ref sinarioinfo, ref stack);
                    break;
                case TagName.fadein:
                    index = TagFunc.FadeInImage(index, name, elm, ref sinarioinfo, ref stack);
                    break;
                case TagName.fadeout:
                    index = TagFunc.FadeOutImage(index, name, elm, ref sinarioinfo, ref stack);
                    break;
                case TagName.inbgm:
                    index = TagFunc.FadeInBGM(index, name, elm, ref sinarioinfo, ref stack);
                    break;
                case TagName.outbgm:
                    index = TagFunc.FadeOutBGM(index, name, elm, ref sinarioinfo, ref stack);
                    break;
                case TagName.playbgm:
                    index = TagFunc.PlayBGM(index, name, elm, ref sinarioinfo, ref stack);
                    break;
                case TagName.stopbgm:
                    index = TagFunc.StopBGM(index, name, elm, ref sinarioinfo, ref stack);
                    break;
                case TagName.playsound:
                    index = TagFunc.PlaySE(index, name, elm, ref sinarioinfo, ref stack);
                    break;
                case TagName.stopsound:
                    index = TagFunc.StopSE(index, name, elm, ref sinarioinfo, ref stack);
                    break;
                case TagName.soundwait:
                    index = TagFunc.WaitSE(index, name, elm, ref sinarioinfo, ref stack);
                    break;
                case TagName.nextstage:
                    index = TagFunc.NextStage(index, name, elm, ref sinarioinfo, ref stack);
                    break;
                default:
                    break;
            }

            return index;
        }
    }
}
