using System;
using System.Collections.Generic;
using System.Text;

using YD = Yanesdk.Draw;
using YI = Yanesdk.Input;

namespace CornerCrash
{
    class TitleLayer : BaseLayer
    {
        string title = "Corner Crash!!";
        string message = "please press the SPACE keay to start";

        YD.GlTexture titletexture;
        YD.GlTexture msgtexture;
        YD.Font font;
        int fontwidth;

        YD.Font smallfont;
        int smallfontwidth;

        YD.Screen2DGl screen;
        YI.Key1 key;
        int wait;

        public TitleLayer(YD.Screen2DGl pscreen)
        {
            screen = pscreen;
            font = new Yanesdk.Draw.Font();
            fontwidth = 48;
            font.Load("msgothic.ttc", fontwidth, 0);
            font.SetColor(0xff, 0xff, 0xff);

            smallfont = new Yanesdk.Draw.Font();
            smallfontwidth = CornerCrashDefine.SMALLFONT_WIDTH;
            smallfont.Load("msgothic.ttc", smallfontwidth, 0);
            smallfont.SetColor(0xff, 0xff, 0xff);

            titletexture = new Yanesdk.Draw.GlTexture();
            msgtexture = new Yanesdk.Draw.GlTexture();
            key = new Yanesdk.Input.Key1();
            wait = 0;
        }

        public override void Control()
        {
            key.Update();

            if (GameState.getInstance().State != GameState.Mode.TITLE)
            {
                return;
            }

            wait--;
            if (wait < 0)
            {
                wait = 0;
            }

            if (wait > 0)
            {
                return;
            }

            if ( (key.IsPull(5) == true) &&
                 (FormInfo.getInstance().IsActive == true) )
            {
                GameState.getInstance().State = GameState.Mode.SHORTSTORY;
                wait = 30;//bEGCg
            }
        }

        public override void DrawLayer()
        {
            if (GameState.getInstance().State != GameState.Mode.TITLE)
            {
                return;
            }

            if ((titletexture == null) || (msgtexture == null))
            {
                return;
            }

            YD.Surface surface = null;

            if (titletexture.Loaded == false)
            {
                titletexture.SetSurface(surface = font.DrawBlendedUnicode(title));
            }
            screen.Blt(titletexture, (CornerCrashDefine.WINDOW_WIDTH - (title.Length * fontwidth)) / 2,
                (CornerCrashDefine.WINDOW_HEIGHT - fontwidth) / 2);

            if (msgtexture.Loaded == false)
            {
                msgtexture.SetSurface(surface = smallfont.DrawBlendedUnicode(message));
            }
            screen.Blt(msgtexture, (CornerCrashDefine.WINDOW_WIDTH - (message.Length * smallfontwidth)) / 2,
                (int)(CornerCrashDefine.WINDOW_HEIGHT - smallfontwidth + fontwidth * 3) / 2);
      }

        public override LayerType Type
        {
            get
            {
                return LayerType.TITLE;
            }
        }

    }
}
