using System;
using System.Collections.Generic;
using System.Text;

namespace CornerCrash
{
    class TurnDirection
    {
        CornerCrash.Character.NowDirection[] table;

        int max;

        public TurnDirection()
        {
            table = new Character.NowDirection[4];
            max = 0;
        }

        public void setupTable(Character charp, BGMap map)
        {
            int mapx, mapy;

            mapx = charp.x / BGMap.MAPCHIP_WIDTH;
            mapy = charp.y / BGMap.MAPCHIP_HEIGHT;

            max = 0;

            if ( (map.BGTypes[map.Map[mapy][mapx]] != BGMap.BGType.CORNER)   &&
                 (map.BGTypes[map.Map[mapy][mapx]] != BGMap.BGType.TJIRO)    &&
                 (map.BGTypes[map.Map[mapy][mapx]] != BGMap.BGType.JYUJIRO)
               )
            {
                return;
            }

            if ((charp.x / BGMap.MAPCHIP_WIDTH) != ((charp.x + charp.sprite.width) / BGMap.MAPCHIP_WIDTH))
            {
                return;
            }

            if ((charp.y / BGMap.MAPCHIP_HEIGHT) != ((charp.y + charp.sprite.height) / BGMap.MAPCHIP_HEIGHT))
            {
                return;
            }

            if (mapy > 0)
            {
                if (map.BGTypes[map.Map[mapy - 1][mapx]] != BGMap.BGType.BLOCK)
                {
                    table[max++] = Character.NowDirection.TOP;
                }
            }

            if (mapy < (map.Map.Length - 1))
            {
                if (map.BGTypes[map.Map[mapy + 1][mapx]] != BGMap.BGType.BLOCK)
                {
                    table[max++] = Character.NowDirection.BOTTOM;
                }
            }

            if (mapx > 0)
            {
                if (map.BGTypes[map.Map[mapy][mapx - 1]] != BGMap.BGType.BLOCK)
                {
                    table[max++] = Character.NowDirection.LEFT;
                }
            }

            if (mapx < (map.Map[mapy].Length - 1))
            {
                if (map.BGTypes[map.Map[mapy][mapx + 1]] != BGMap.BGType.BLOCK)
                {
                    table[max++] = Character.NowDirection.RIGHT;
                }
            }
        }

        public bool IsCorner()
        {
            if (max > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        public Character.NowDirection getTurnDirection(Random rnd)
        {
            if (max == 0)
            {
                return Character.NowDirection.VOID;
            }

            int direct = rnd.Next();

            direct = direct % max;

            return table[direct];
        }
    }
}
